class osd
 {
 	private:
 	 enum { _COL=33, _ROW=2, _XPIX=32, _YPIX=30 };
 	 int _X,_Y,_i;
 	 int *lives,*score;
 	 int weapon_frame;
 	 int alpha;
 	 bool powerup;
 	 timer *ti[5];
 	 BITMAP *frame[_COL*_ROW];
 	 BITMAP *out;

 	 void loadSpriteFrames(char *);
 	 void assignSpriteFrame(osd *);
 	 void setOutBitmap(BITMAP *);
 	
 	public:
 	 osd(char *,int,int,BITMAP *,int i=0,osd *p=NULL);
 	 ~osd();
 	 void drawOSD(int,int);
 	 void timeOSD();
 	 void animOSD();
 	 bool inScreen();
 	 void setActWeapon(int,bool);
 	 void setLivesP(int *);
 	 void setScoreP(int *);
 	 void debug();
 };

osd::osd(char *filename, int start_x, int start_y, BITMAP *out, int i, osd *p)
 {
 	_i=i;
 	alpha=0;
 	powerup=0;
 	if(!_i) loadSpriteFrames(filename); else assignSpriteFrame(p);
 	setOutBitmap(out);
 	weapon_frame=6;
 	//pos_x=start_x; pos_y=start_y; scroll_x=0; scroll_y=0; jump_y=0;
 	ti[0]=new timer(4);  // ??? time
 	ti[1]=new timer(0);  
 	ti[2]=new timer(0);  
 	ti[3]=new timer(0); 
 	ti[4]=new timer(0);
 }

osd::~osd()
 {
 	for(int i=0;i<5;i++) delete(ti[i]);
 	if(_i==0)
 	 {
    //for(int i=0;i<2;i++)    destroy_sample(sound[i]);
 	  for(int i=0;i<_COL*_ROW;i++) destroy_bitmap(frame[i]);
 	  //for(int i=0;i<_COL*_ROW;i++) destroy_bitmap(frame_col[i]);
 	 }
 }

void osd::loadSpriteFrames(char *filename)
 {
 	BITMAP *aux;

  aux=load_bmp(filename,NULL);
  //for(int i=0;i<24;i++) frame[i]=create_sub_bitmap(aux,_XPIX*i+i,0,_XPIX,_YPIX);
  for(int i=0;i<_ROW;i++)
   for(int j=0;j<_COL;j++)
    {
     //frame[j+_COL*i]=create_sub_bitmap(aux,_XPIX*j+j,_YPIX*i+i,_XPIX,_YPIX);
     frame[j+_COL*i]=create_bitmap(_XPIX,_YPIX);
     blit(aux,frame[j+_COL*i],_XPIX*j+j,_YPIX*i+i,0,0,frame[j+_COL*i]->w,frame[j+_COL*i]->h);
    }
  destroy_bitmap(aux);
 }

void osd::assignSpriteFrame(osd *p)
 {
 	for(int i=0;i<_ROW*_COL;i++)
 	 {
 	  frame[i]=p->frame[i];
 	 }
 }

void osd::setOutBitmap(BITMAP *bmp) { out=bmp; }

void osd::timeOSD()
 {
 	for(int i=0;i<5;i++) ti[i]->time();
 }

void osd::animOSD()
 {
 	/*if(dead) return;
 	if(explode) 
 	 {
 	 	if(ti[1]->isOn()) act_frame++;
 	 	if(act_frame==35)
 	 	 {
 	 	  act_frame=40;
 	 	  explode=0;
 	 	  dead=1;
 	 	 }
 	 	return;
 	 }
 	if(!fly) if(random(100)==1) fly=1;
 	if(fly)  { if(side) dx=-2; else dx=2; if(ti[3]->isOn()) { act_frame++; if(act_frame>2) act_frame=1; } }
 	if(hitted) { play_sample(sound[0],120,150,1000,0); hitted=0; act_frame=19; stop=1; energy--; if(energy==0) { explode=1; fly=0; stop=0; play_sample(sound[1],120,150,1000,0); } else explode=0; ti[2]->reset(); return; }
 	if(stop) { dx=0; act_frame=19; if(ti[2]->isOn()) stop=0; }
 	pos_x+=dx;
 	pos_y+=dy;*/
 	/*if(climb) // Sulla scala
   }*/
 }

void osd::drawOSD(int sx,int sy)
 {
  //pivot_sprite(rend,car,rend_x,rend_y,piv_cx,piv_cy,itofix(ang1));
  _X=0; _Y=0; alpha=180;
 	drawing_mode(DRAW_MODE_TRANS,out,0,0);
 	set_trans_blender(0,0,0,alpha);
 	 	
 	draw_trans_sprite(out,frame[4],_X+7,_Y+22); draw_trans_sprite(out,frame[5],_X+7+32,_Y+22); // Time hud
  draw_trans_sprite(out,frame[3],_X+170,_Y+194); // Weapon hud
  //if(powerup) draw_trans_sprite(out,frame[2],_X+178,_Y+201); // Powerup
  if(powerup) draw_trans_sprite(out,frame[weapon_frame+33],_X+178,_Y+201);  // Weapon (with powerup)
  else        draw_trans_sprite(out,frame[weapon_frame],_X+178,_Y+201);     // Weapon 
  textprintf_ex(out,font,_X+8,_Y,makecol32(255,0,0),-1,"Player 1"); // Player 1
  textprintf_ex(out,font,_X+16,_Y+12,makecol32(200,200,200),-1,"%d",*score); // Score
  for(int i=0;i<*lives-1;i++) draw_trans_sprite(out,frame[1],_X+363-i*18,_Y+210); // Lives
   
 	set_trans_blender(0,0,0,255);
 	drawing_mode(DRAW_MODE_SOLID,out,0,0);
 }

bool osd::inScreen()
 {
 	if(_X>=-46 && _X<=384) return true;
 	else return false;
 }

void osd::setActWeapon(int w,bool pow)
 {
 	powerup=pow;
 	if(w==LANCE) weapon_frame=6;
 	if(w==KNIFE) weapon_frame=7;
 	if(w==AXE)   weapon_frame=8;
 	if(w==SWORD) weapon_frame=9;
 	if(w==ARROW) weapon_frame=10;
 }

void osd::setLivesP(int *p) { lives=p; }

void osd::setScoreP(int *p) { score=p; }

void osd::debug() { }
