#define VER "0.36"
#define CFGFILE "config.cfg"
#define FADETIME 18

#define N_STAGE 4
#define N_PLAT 30
#define N_SK 8
#define N_ZO 10
#define N_VO 1
#define N_BL 7
#define N_RA 3
#define N_RK 1
#define N_P2 7
#define N_GO 12
#define N_BA 8
#define N_GI 6
#define N_FW 10
#define N_IN 5
#define N_FG 6
#define N_CL 8
#define N_BBOX 12

bool L_B=1,L_0=1,L_1=1,L_S=1,L_H=1,L_OSD=1,DBUG=0,VSYNC=1;
int MS=0,OMS=0,FPS=0,fps=0;
int SCREENRES,SCREENX,SCREENY,SCREEND,G_RESX,G_RESY,MFPS;
int RESTART_X,RESTART_Y;
bool FSCREEN,DEBUG,STRETCH;

int STAGE,LIVES,READY_GO,SCORE,GAME_OVER,BONUS_SEQ;

BITMAP *VSCR;
MIDI *music[N_STAGE];

player           *PL;
osd              *OSD;
skeleton         *SK[N_SK];
zombie           *ZO[N_ZO];
blade            *BL[N_BL];
volture          *VO[N_VO];
red_arremer      *RA[N_RA];
red_arremer_king *RK[N_RK];
plant_mk2        *P2[N_P2];
ghost            *GO[N_GO];
bat              *BA[N_BA];
giant            *GI[N_GI];
firewall         *FW[N_FW];
insect           *IN[N_IN];
fire_grizzly     *FG[N_FG];
clam             *CL[N_CL];
map              *MAP0[N_STAGE],*MAP1[N_STAGE],*MAPH[N_STAGE];
mobile           **MOBILE;
thunder          *TH_SFX;
fog              *FO_SFX;
fire             *FI_SFX;
water            *WA_SFX[2];
rain             *RA_SFX[2];
bonus            *BONUSB[N_BBOX];
bonus            *KEY,*SHILD;

void init();
void initEnv();
void initObjects();
void initGame(int st=0,int li=3);
void restartStage(int);
void resetObj();
void checkGame();
void readConf(int *,bool *,bool *,bool *);
void writeConf(int,bool,bool,bool);
void readyGo();
void gameOver();
void Intro();
void Title();
void stageMap();
void layer_back();
void layer_0();
void layer_1();
void layer_s();
void layer_h();
void layer_OSD(int);
void Player();
void Enemies();
void Scroll();
void Collision();
void collisionPlayerBonus();
void collisionShildBullets();
void collisionPlayerEnemies();
void collisionWeaponEnemies();
void collisionPlayerBullets();
void rePaint(int);
void debug(BITMAP *,int);

void init()
 {
 	initEnv();
  allegro_init();
  install_keyboard();
  install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,NULL);
  set_volume(255,136); 
  VSCR=create_bitmap_ex(SCREEND,G_RESX,G_RESY);
  set_color_depth(SCREEND);
  if(FSCREEN) { if(set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,SCREENX,SCREENY,0,0)==-1) { exit(0); } }
  else { if(set_gfx_mode(GFX_AUTODETECT_WINDOWED,SCREENX,SCREENY,0,0)==-1) { exit(0); } }
  //drawing_mode(DRAW_MODE_TRANS,screen,0,0);
  //set_trans_blender(128,128,128,128); // Transparent sprite if use draw_trans_sprite(...)
  LOCK_FUNCTION(count);
  LOCK_VARIABLE(counter);  
  install_int_ex(count,MSEC_TO_TIMER(1));
  STAGE=0;
  initObjects();
 }

void initEnv()
 {
 	MFPS=60;
 	G_RESX=384; G_RESY=224;
  SCREENRES=3;
 	FSCREEN=false;
 	DEBUG=false;
 	STRETCH=false;
 	readConf(&SCREENRES,&FSCREEN,&STRETCH,&DEBUG);
 	if(SCREENRES==0) { SCREENX=320; SCREENY=200; SCREEND=32; }
 	if(SCREENRES==1) { SCREENX=320; SCREENY=240; SCREEND=32; }
 	if(SCREENRES==2) { SCREENX=384; SCREENY=224; SCREEND=32; }
 	if(SCREENRES==3) { SCREENX=400; SCREENY=300; SCREEND=32; }
 	if(SCREENRES==4) { SCREENX=512; SCREENY=384; SCREEND=32; }
 	if(SCREENRES==5) { SCREENX=640; SCREENY=480; SCREEND=32; }
 	if(SCREENRES==6) { SCREENX=768; SCREENY=448; SCREEND=32; }
 }

void initGame(int st,int li)
 {
 	// New game starts
 	STAGE=st; LIVES=li; READY_GO=2; SCORE=0; GAME_OVER=0;
 	BONUS_SEQ=0;
 	// Resettare posizione giocatore ed armi per inizio partita 
  resetObj();
  stageMap();
 }

void resetObj()
 {
 	BONUS_SEQ=0;
  PL->setPlatformMap(MAP1[STAGE]);
  PL->setHightMap(MAPH[STAGE]);
  PL->setBackgroundMap(MAP0[STAGE]);
  PL->calcMax();
  PL->setShildP(SHILD);
  for(int i=0;i<N_BBOX;i++) BONUSB[i]->resetObj(false);
  KEY->resetObj(false); SHILD->resetObj(false);
 	if(STAGE==0)
 	 {
 	 	// Player position
 	  if(PL->getGlobX()<3700)  { RESTART_X=130; RESTART_Y=607; }
  	if(PL->getGlobX()>=3700) { RESTART_X=3700; RESTART_Y=605; }
    PL->resetPlayer(RESTART_X,RESTART_Y);
 	 	// Blade
 	 	BL[0]->setStartX(1895); BL[0]->setStartY(108+224*2); BL[0]->setMaxY(158+224*2); BL[0]->setCount(5);
 	 	BL[1]->setStartX(2087); BL[1]->setStartY(121+224*2); BL[1]->setMaxY(160+224*2); BL[1]->setCount(2);
 	 	BL[2]->setStartX(2247); BL[2]->setStartY(121+224*2); BL[2]->setMaxY(160+224*2); BL[2]->setCount(7);
 	 	BL[3]->setStartX(1863); BL[3]->setStartY(9+224*2);   BL[3]->setMaxY(60+224*2);  BL[3]->setCount(4);
 	 	BL[4]->setStartX(2071); BL[4]->setStartY(-4+224*2);  BL[4]->setMaxY(48+224*2);  BL[4]->setCount(8);
 	 	BL[5]->setStartX(2503); BL[5]->setStartY(121+224*2); BL[5]->setMaxY(160+224*2); BL[5]->setCount(8);
 	 	BL[6]->setStartX(2663); BL[6]->setStartY(46+224*2);  BL[6]->setMaxY(126+224*2); BL[6]->setCount(3);
 	 	for(int i=0;i<N_BL;i++) BL[i]->resetObj(true);
 	 	// Zombie
 	 	for(int i=0;i<N_ZO;i++) { ZO[i]->setStartX(194); ZO[i]->setStartY(0); ZO[i]->resetObj(true); }
 	 	// Skeleton
 	 	for(int i=0;i<N_SK;i++) { SK[i]->setStartX(194); SK[i]->setStartY(152); SK[i]->resetObj(true); }
 	 	// Plant mk2
 	 	P2[0]->setStartX(1364);     P2[0]->setStartY(554);
 	 	P2[1]->setStartX(1698);     P2[1]->setStartY(487);
 	 	P2[2]->setStartX(2202);     P2[2]->setStartY(608);
 	 	P2[3]->setStartX(2940);     P2[3]->setStartY(609);
 	 	P2[4]->setStartX(3084+768); P2[4]->setStartY(609);
 	 	P2[5]->setStartX(3730+768); P2[5]->setStartY(448);
    P2[6]->setStartX(4606+768); P2[6]->setStartY(189);
 	 	for(int i=0;i<N_P2;i++) P2[i]->resetObj(true);
 	 	// Volture
 	 	VO[0]->setStartX(940); VO[0]->setStartY(550);
 	 	for(int i=0;i<N_VO;i++) VO[i]->resetObj(true);
 	 	// Red arremer
 	 	RA[0]->setStartX(3440+768); RA[0]->setStartY(580);
 	 	RA[1]->setStartX(4440+768); RA[1]->setStartY(420);
 	 	RA[2]->setStartX(912);      RA[2]->setStartY(513);
 	 	for(int i=0;i<N_RA;i++) RA[i]->resetObj(true);
 	 	// Red arremer King
 	 	RK[0]->setStartX(5274+768); RK[0]->setStartY(606);
 	 	for(int i=0;i<N_RK;i++) RK[i]->resetObj(true);
 	 	RK[0]->setExitKeyP(KEY);	 	
 	 	for(int i=0;i<N_RK;i++) RK[i]->resetObj(true);
 	 	// Ghost
 	 	for(int i=0;i<N_GO;i++) { GO[i]->setStartX(2550); GO[i]->setStartY(1300); GO[i]->resetObj(true); }
 	 	// Bat
 	 	for(int i=0;i<N_BA;i++) BA[i]->resetObj(false);
 	 	// Giant
 	 	for(int i=0;i<N_GI;i++) GI[i]->resetObj(false);
 	 	// Firewall
 	 	for(int i=0;i<N_FW;i++) FW[i]->resetObj(false);
 	 	// Insect
 	 	for(int i=0;i<N_IN;i++) IN[i]->resetObj(false);
 	 	// Fire grizzly
 	 	for(int i=0;i<N_FG;i++) FG[i]->resetObj(false);
 	 	// Clam
 	 	for(int i=0;i<N_CL;i++) CL[i]->resetObj(false);

 	 	// Mobile (da 0 a 11 Magic box)
    MOBILE[0]->setStartX(100);  MOBILE[0]->setStartY(607); MOBILE[0]->setDisX(-70); MOBILE[0]->setDisY(-36);   MOBILE[0]->setFGround(true);
    MOBILE[1]->setStartX(778);  MOBILE[1]->setStartY(576); MOBILE[1]->setDisX(80);  MOBILE[1]->setDisY(50);    MOBILE[1]->setFGround(true);
    MOBILE[2]->setStartX(1496); MOBILE[2]->setStartY(587); MOBILE[2]->setDisX(-1);  MOBILE[2]->setDisY(-35);   MOBILE[2]->setFGround(true);
    MOBILE[3]->setStartX(2218); MOBILE[3]->setStartY(608); MOBILE[3]->setDisX(-1);  MOBILE[3]->setDisY(-134);  MOBILE[3]->setFGround(true);
    MOBILE[4]->setStartX(3100); MOBILE[4]->setStartY(607); MOBILE[4]->setDisX(10);  MOBILE[4]->setDisY(-72);   MOBILE[4]->setFGround(true);
    MOBILE[5]->setStartX(3800); MOBILE[5]->setStartY(608); MOBILE[5]->setDisX(96);  MOBILE[5]->setDisY(50);    MOBILE[5]->setFGround(true);
    MOBILE[6]->setStartX(4366); MOBILE[6]->setStartY(607); MOBILE[6]->setDisX(80);  MOBILE[6]->setDisY(-22);   MOBILE[6]->setFGround(true);
    MOBILE[7]->setStartX(5228); MOBILE[7]->setStartY(505); MOBILE[7]->setDisX(-1);  MOBILE[7]->setDisY(-22);   MOBILE[7]->setFGround(true);
    MOBILE[8]->setStartX(4560); MOBILE[8]->setStartY(450); MOBILE[8]->setDisX(-50); MOBILE[8]->setDisY(-36);   MOBILE[8]->setFGround(true);
    MOBILE[9]->setStartX(5042); MOBILE[9]->setStartY(229+1); MOBILE[9]->setDisX(-50); MOBILE[9]->setDisY(-36); MOBILE[9]->setFGround(true);
    MOBILE[10]->setStartX(0);   MOBILE[10]->setStartY(0);  MOBILE[10]->setDisX(0);  MOBILE[10]->setDisY(0);    MOBILE[10]->setFGround(true);
    MOBILE[11]->setStartX(0);   MOBILE[11]->setStartY(0);  MOBILE[11]->setDisX(0);  MOBILE[11]->setDisY(0);    MOBILE[11]->setFGround(true);

    MOBILE[12]->setStartX(360);  MOBILE[12]->setStartY(608); MOBILE[12]->setStartFrame(01); MOBILE[12]->setEndFrame(01); MOBILE[12]->setType(0); MOBILE[12]->setFGround(true);
    MOBILE[13]->setStartX(580);  MOBILE[13]->setStartY(613); MOBILE[13]->setStartFrame(01); MOBILE[13]->setEndFrame(01); MOBILE[13]->setType(0); MOBILE[13]->setFGround(true);
    MOBILE[14]->setStartX(1160); MOBILE[14]->setStartY(606); MOBILE[14]->setStartFrame(02); MOBILE[14]->setEndFrame(02); MOBILE[14]->setType(0); MOBILE[14]->setFGround(true);
    MOBILE[15]->setStartX(1634); MOBILE[15]->setStartY(607); MOBILE[15]->setStartFrame(01); MOBILE[15]->setEndFrame(01); MOBILE[15]->setType(0); MOBILE[15]->setFGround(true);
    MOBILE[16]->setStartX(2976); MOBILE[16]->setStartY(607); MOBILE[16]->setStartFrame(03); MOBILE[16]->setEndFrame(04); MOBILE[16]->setType(1); MOBILE[16]->setFGround(true);
    MOBILE[17]->setStartX(3260); MOBILE[17]->setStartY(624); MOBILE[17]->setStartFrame(03); MOBILE[17]->setEndFrame(04); MOBILE[17]->setType(1); MOBILE[17]->setFGround(true);
    MOBILE[18]->setStartX(3350); MOBILE[18]->setStartY(626); MOBILE[18]->setStartFrame(03); MOBILE[18]->setEndFrame(04); MOBILE[18]->setType(1); MOBILE[18]->setFGround(true);
    MOBILE[19]->setStartX(3538); MOBILE[19]->setStartY(624); MOBILE[19]->setStartFrame(05); MOBILE[19]->setEndFrame(05); MOBILE[19]->setType(0); MOBILE[19]->setFGround(true);
    MOBILE[20]->setStartX(3586); MOBILE[20]->setStartY(624); MOBILE[20]->setStartFrame(05); MOBILE[20]->setEndFrame(05); MOBILE[20]->setType(0); MOBILE[20]->setFGround(true);
    MOBILE[21]->setStartX(3634); MOBILE[21]->setStartY(624); MOBILE[21]->setStartFrame(05); MOBILE[21]->setEndFrame(05); MOBILE[21]->setType(0); MOBILE[21]->setFGround(true);
    MOBILE[22]->setStartX(4024); MOBILE[22]->setStartY(598); MOBILE[22]->setStartFrame(23); MOBILE[22]->setEndFrame(23); MOBILE[22]->setType(0); MOBILE[22]->setFGround(true);
    MOBILE[23]->setStartX(4788); MOBILE[23]->setStartY(378); MOBILE[23]->setStartFrame(23); MOBILE[23]->setEndFrame(23); MOBILE[23]->setType(0); MOBILE[23]->setFGround(true);
    
    for(int i=0;i<N_PLAT;i++) MOBILE[i]->resetObj(false);
    for(int i=0;i<=11;i++)    MOBILE[i]->resetObj(true);
    for(int i=12;i<=23;i++)   MOBILE[i]->resetObj(true);
 	 	// Other
 	 	TH_SFX->setStartX(4802+768); TH_SFX->setStartY(520); TH_SFX->resetSFX(true);
 	 	FO_SFX->setStartX(2300);     FO_SFX->setStartY(448); FO_SFX->resetSFX(true);
 	 	FI_SFX->resetSFX(false);
 	 	WA_SFX[0]->setStartX(2864); WA_SFX[0]->setStartY(655); WA_SFX[0]->resetSFX(true); WA_SFX[0]->setScrollSpeed(0); WA_SFX[0]->setWaveSpeed(-1); WA_SFX[0]->setWaterLen(18); WA_SFX[0]->setAlpha(200);
 	 	WA_SFX[1]->resetSFX(false);
 	 	RA_SFX[0]->setStartX(4001); RA_SFX[0]->setStartY(516); RA_SFX[0]->resetSFX(true,0);
 	 	RA_SFX[1]->setStartX(4200); RA_SFX[1]->setStartY(516); RA_SFX[1]->resetSFX(true,1);
    for(int i=0;i<N_ZO;i++) ZO[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_SK;i++) SK[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_GI;i++) GI[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_FG;i++) FG[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_BBOX;i++) BONUSB[i]->setPlatformMap(MAP1[STAGE]);
    KEY->setPlatformMap(MAP1[STAGE]); SHILD->setPlatformMap(MAP1[STAGE]);
   }
 	if(STAGE==1)
 	 {
 	 	// Player position
 	  //if(PL->getGlobX()<3000)  { RESTART_X=130+3500;  RESTART_Y=607-260; }
 	  if(PL->getGlobX()<3000)  { RESTART_X=130;  RESTART_Y=607; }
  	if(PL->getGlobX()>=3600) { RESTART_X=3600; RESTART_Y=348; }
    PL->resetPlayer(RESTART_X,RESTART_Y);
 	 	// Blade
 	 	for(int i=0;i<N_BL;i++) BL[i]->resetObj(false);
 	 	// Zombie
 	 	for(int i=0;i<N_ZO;i++) ZO[i]->resetObj(false);
 	 	// Skeleton
 	 	for(int i=0;i<N_SK;i++) SK[i]->resetObj(false);
 	 	// Plant mk2
 	 	P2[0]->setStartX(300); P2[0]->setStartY(605);
 	 	P2[1]->setStartX(340); P2[1]->setStartY(604);
 	 	P2[2]->setStartX(400); P2[2]->setStartY(605);
 	 	P2[3]->setStartX(460); P2[3]->setStartY(603);
 	 	P2[4]->setStartX(490); P2[4]->setStartY(605);
 	 	P2[5]->setStartX(520); P2[5]->setStartY(604);
    P2[6]->setStartX(580); P2[6]->setStartY(603);
 	 	for(int i=0;i<N_P2;i++) P2[i]->resetObj(true);
 	 	// Volture
 	 	for(int i=0;i<N_VO;i++) VO[i]->resetObj(false);
 	 	// Red arremer
 	 	for(int i=0;i<N_RA;i++) RA[i]->resetObj(false);
 	 	// Red arremer King
 	 	RK[0]->setStartX(6830); RK[0]->setStartY(390);
 	 	for(int i=0;i<N_RK;i++) RK[i]->resetObj(true);
 	 	RK[0]->setExitKeyP(KEY);
 	 	// Ghost
 	 	for(int i=0;i<N_GO;i++) GO[i]->resetObj(false);
 	 	// Bat
 	 	for(int i=0;i<N_BA;i++) BA[i]->resetObj(false);
 	 	// Giant
 	 	for(int i=0;i<N_GI;i++) GI[i]->resetObj(false); 	 	
 	 	// Firewall
 	 	FW[0]->setStartX(4300); FW[0]->setStartY(6+224*2);   FW[0]->setMaxY(100); FW[0]->setCount(5);  FW[0]->setMaxCount(5);
 	 	FW[1]->setStartX(4450); FW[1]->setStartY(6+224*2);   FW[1]->setMaxY(100); FW[1]->setCount(16); FW[1]->setMaxCount(18);
 	 	FW[2]->setStartX(4700); FW[2]->setStartY(22+224*2);  FW[2]->setMaxY(100); FW[2]->setCount(1);  FW[2]->setMaxCount(2);
 	 	FW[3]->setStartX(4772); FW[3]->setStartY(22+224*2);  FW[3]->setMaxY(100); FW[3]->setCount(6);  FW[2]->setMaxCount(12);
 	 	FW[4]->setStartX(5725); FW[4]->setStartY(190+224*2); FW[4]->setMaxY(100); FW[4]->setCount(10); FW[4]->setMaxCount(15);
 	 	FW[5]->setStartX(6000); FW[5]->setStartY(190+224*2); FW[5]->setMaxY(100); FW[5]->setCount(12); FW[5]->setMaxCount(18);
 	 	FW[6]->setStartX(5967); FW[6]->setStartY(190+224*2); FW[6]->setMaxY(100); FW[6]->setCount(5);  FW[6]->setMaxCount(20);
 	 	FW[7]->setStartX(6200); FW[7]->setStartY(190+224*2); FW[7]->setMaxY(100); FW[7]->setCount(2);  FW[7]->setMaxCount(10);
 	 	FW[8]->setStartX(6200); FW[8]->setStartY(210+224*2); FW[8]->setMaxY(100); FW[8]->setCount(13); FW[8]->setMaxCount(20);
 	 	FW[9]->setStartX(6258); FW[9]->setStartY(190+224*2); FW[9]->setMaxY(100); FW[9]->setCount(8);  FW[9]->setMaxCount(16);
 	 	for(int i=0;i<N_FW;i++) FW[i]->resetObj(true);
 	 	// Insect
 	 	for(int i=0;i<N_IN;i++) { IN[i]->setStartX(1900); IN[i]->setStartY(1200); IN[i]->resetObj(true); }
 	 	// Fire grizzly
 	 	for(int i=0;i<N_FG;i++) FG[i]->resetObj(false);
 	 	FG[0]->setStartX(4400); FG[0]->setStartY(607); FG[0]->setMinX(4280); FG[0]->setMaxX(4500);
 	 	FG[1]->setStartX(5000); FG[1]->setStartY(607); FG[1]->setMinX(4850); FG[1]->setMaxX(5300);
 	 	FG[2]->setStartX(5120); FG[2]->setStartY(607); FG[2]->setMinX(4850); FG[2]->setMaxX(5310);
 	 	FG[3]->setStartX(6300); FG[3]->setStartY(607); FG[3]->setMinX(6030); FG[3]->setMaxX(6270);
 	 	for(int i=0;i<4;i++) FG[i]->resetObj(true);
    // Clam
 	 	for(int i=0;i<N_CL;i++) CL[i]->resetObj(false);

 	 	// Mobile (da 0 a 11 Magic box)
    MOBILE[0]->setStartX(150);  MOBILE[0]->setStartY(607); MOBILE[0]->setDisX(0);  MOBILE[0]->setDisY(0);  MOBILE[0]->setFGround(true);
    MOBILE[1]->setStartX(180);  MOBILE[1]->setStartY(607); MOBILE[1]->setDisX(0);  MOBILE[1]->setDisY(0);  MOBILE[1]->setFGround(true);
    MOBILE[2]->setStartX(230);  MOBILE[2]->setStartY(607); MOBILE[2]->setDisX(0);  MOBILE[2]->setDisY(0);  MOBILE[2]->setFGround(true);
    MOBILE[3]->setStartX(280);  MOBILE[3]->setStartY(607); MOBILE[3]->setDisX(0);  MOBILE[3]->setDisY(0);  MOBILE[3]->setFGround(true);
    MOBILE[4]->setStartX(330);  MOBILE[4]->setStartY(607); MOBILE[4]->setDisX(0);  MOBILE[4]->setDisY(0);  MOBILE[4]->setFGround(true);
    MOBILE[5]->setStartX(380);  MOBILE[5]->setStartY(607); MOBILE[5]->setDisX(0);  MOBILE[5]->setDisY(0);  MOBILE[5]->setFGround(true);
    MOBILE[6]->setStartX(430);  MOBILE[6]->setStartY(607); MOBILE[6]->setDisX(0);  MOBILE[6]->setDisY(0);  MOBILE[6]->setFGround(true);
    MOBILE[7]->setStartX(0);    MOBILE[7]->setStartY(0);   MOBILE[7]->setDisX(0);  MOBILE[7]->setDisY(0);  MOBILE[7]->setFGround(true);
    MOBILE[8]->setStartX(0);    MOBILE[8]->setStartY(0);   MOBILE[8]->setDisX(0);  MOBILE[8]->setDisY(0);  MOBILE[8]->setFGround(true);
    MOBILE[9]->setStartX(0);    MOBILE[9]->setStartY(0);   MOBILE[9]->setDisX(0);  MOBILE[9]->setDisY(0);  MOBILE[9]->setFGround(true);
    MOBILE[10]->setStartX(0);   MOBILE[10]->setStartY(0);  MOBILE[10]->setDisX(0); MOBILE[10]->setDisY(0); MOBILE[10]->setFGround(true);
    MOBILE[11]->setStartX(0);   MOBILE[11]->setStartY(0);  MOBILE[11]->setDisX(0); MOBILE[11]->setDisY(0); MOBILE[11]->setFGround(true);

 	 	MOBILE[12]->setStartX(74);   MOBILE[12]->setStartY(625); MOBILE[12]->setStartFrame(24); MOBILE[12]->setEndFrame(24); MOBILE[12]->setType(0); MOBILE[12]->setFGround(true);
    MOBILE[13]->setStartX(610);  MOBILE[13]->setStartY(608); MOBILE[13]->setStartFrame(22); MOBILE[13]->setEndFrame(22); MOBILE[13]->setType(0); MOBILE[13]->setFGround(true);
    MOBILE[14]->setStartX(1160); MOBILE[14]->setStartY(506); MOBILE[14]->setStartFrame(22); MOBILE[14]->setEndFrame(22); MOBILE[14]->setType(0); MOBILE[14]->setFGround(true);
    
    /*MOBILE[15]->setStartX(670);  MOBILE[15]->setStartY(670); MOBILE[15]->setStartFrame(55); MOBILE[15]->setEndFrame(55); MOBILE[15]->setType(0); MOBILE[15]->setFGround(false);
    MOBILE[16]->setStartX(720);  MOBILE[16]->setStartY(660); MOBILE[16]->setStartFrame(55); MOBILE[16]->setEndFrame(55); MOBILE[16]->setType(0); MOBILE[16]->setFGround(false);
    MOBILE[17]->setStartX(770);  MOBILE[17]->setStartY(650); MOBILE[17]->setStartFrame(55); MOBILE[17]->setEndFrame(55); MOBILE[17]->setType(0); MOBILE[17]->setFGround(false);
    MOBILE[18]->setStartX(820);  MOBILE[18]->setStartY(640); MOBILE[18]->setStartFrame(55); MOBILE[18]->setEndFrame(55); MOBILE[18]->setType(0); MOBILE[18]->setFGround(false);
    MOBILE[19]->setStartX(870);  MOBILE[19]->setStartY(630); MOBILE[19]->setStartFrame(55); MOBILE[19]->setEndFrame(55); MOBILE[19]->setType(0); MOBILE[19]->setFGround(false);
    MOBILE[20]->setStartX(920);  MOBILE[20]->setStartY(620); MOBILE[20]->setStartFrame(55); MOBILE[20]->setEndFrame(55); MOBILE[20]->setType(0); MOBILE[20]->setFGround(false);
    MOBILE[21]->setStartX(970);  MOBILE[21]->setStartY(610); MOBILE[21]->setStartFrame(55); MOBILE[21]->setEndFrame(55); MOBILE[21]->setType(0); MOBILE[21]->setFGround(false);
    MOBILE[22]->setStartX(1020); MOBILE[22]->setStartY(600); MOBILE[22]->setStartFrame(55); MOBILE[22]->setEndFrame(55); MOBILE[22]->setType(0); MOBILE[22]->setFGround(false);
    MOBILE[23]->setStartX(1070); MOBILE[23]->setStartY(590); MOBILE[23]->setStartFrame(55); MOBILE[23]->setEndFrame(55); MOBILE[23]->setType(0); MOBILE[23]->setFGround(false);*/

    for(int i=0;i<N_PLAT;i++) MOBILE[i]->resetObj(false);
    for(int i=0;i<=11;i++)    MOBILE[i]->resetObj(true);
    for(int i=12;i<=14;i++)   MOBILE[i]->resetObj(true);
 	 	// Other
 	 	TH_SFX->resetSFX(false);
 	 	FO_SFX->resetSFX(false);
 	 	FI_SFX->setStartX(3996); FI_SFX->setStartY(415); FI_SFX->resetSFX(true); FI_SFX->setPower(130); FI_SFX->setFade(true);
 	 	WA_SFX[0]->resetSFX(false);
 	 	WA_SFX[1]->resetSFX(false);
 	 	RA_SFX[0]->resetSFX(false,0);
 	 	RA_SFX[1]->resetSFX(false,1);
    for(int i=0;i<N_ZO;i++) ZO[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_SK;i++) SK[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_GI;i++) GI[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_FG;i++) FG[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_BBOX;i++) BONUSB[i]->setPlatformMap(MAP1[STAGE]);
    KEY->setPlatformMap(MAP1[STAGE]); SHILD->setPlatformMap(MAP1[STAGE]);
   }
 	if(STAGE==2)
 	 {
 	 	// Player position
 	  //if(PL->getGlobX()<3000)  { RESTART_X=130+3500;  RESTART_Y=607-260; }
 	  if(PL->getGlobX()<3000)  { RESTART_X=130;  RESTART_Y=595; }
  	if(PL->getGlobX()>=3600) { RESTART_X=3600-500; RESTART_Y=348; }
    PL->resetPlayer(RESTART_X,RESTART_Y);
 	 	// Blade
 	 	for(int i=0;i<N_BL;i++) BL[i]->resetObj(false);
 	 	// Zombie
 	 	for(int i=0;i<N_ZO;i++) ZO[i]->resetObj(false);
 	 	// Skeleton
 	 	for(int i=0;i<N_SK;i++) SK[i]->resetObj(false);
 	 	// Plant mk2
 	 	for(int i=0;i<N_P2;i++) P2[i]->resetObj(false);
 	 	P2[0]->setStartX(850);  P2[0]->setStartY(591);
 	 	P2[1]->setStartX(1320); P2[1]->setStartY(578);
 	 	P2[2]->setStartX(2826); P2[2]->setStartY(449);
 	 	P2[3]->setStartX(3694); P2[3]->setStartY(548);
 	 	P2[4]->setStartX(4490); P2[4]->setStartY(342);
 	 	P2[5]->setStartX(4228); P2[5]->setStartY(316);
 	 	P2[6]->setStartX(4760); P2[6]->setStartY(342);
 	 	for(int i=0;i<N_P2;i++) P2[i]->resetObj(true);
 	 	// Volture
 	 	VO[0]->setStartX(2240); VO[0]->setStartY(568);
 	 	for(int i=0;i<N_VO;i++) VO[i]->resetObj(true); 	 	
 	 	// Red arremer
 	 	for(int i=0;i<N_RA;i++) RA[i]->resetObj(false);
 	 	RA[0]->setStartX(500);  RA[0]->setStartY(591); RA[0]->resetObj(true);
 	 	RA[1]->setStartX(2600); RA[1]->setStartY(449); RA[1]->resetObj(true);
 	 	// Red arremer King
 	 	RK[0]->setStartX(5220); RK[0]->setStartY(520);
 	 	for(int i=0;i<N_RK;i++) RK[i]->resetObj(true);
 	 	RK[0]->setExitKeyP(KEY);
 	 	// Ghost
 	 	for(int i=0;i<N_GO;i++) GO[i]->resetObj(false);
 	 	// Bat
 	 	for(int i=0;i<N_BA;i++) { BA[i]->setStartX(0); BA[i]->setStartY(6000); BA[i]->resetObj(true); }
 	 	// Giant
 	 	GI[0]->setStartX(1358); GI[0]->setStartY(576); GI[0]->setMinX(850);  GI[0]->setMaxX(1500);
 	 	GI[1]->setStartX(2100); GI[1]->setStartY(449); GI[1]->setMinX(1620); GI[1]->setMaxX(2050);
 	 	GI[2]->setStartX(3200); GI[2]->setStartY(449); GI[2]->setMinX(1950); GI[2]->setMaxX(2700);
 	 	GI[3]->setStartX(2600); GI[3]->setStartY(576); GI[3]->setMinX(1600); GI[3]->setMaxX(2600);
 	 	GI[4]->setStartX(3200); GI[4]->setStartY(322); GI[4]->setMinX(1900); GI[4]->setMaxX(2750);
 	 	GI[5]->setStartX(2800); GI[5]->setStartY(322); GI[5]->setMinX(1700); GI[5]->setMaxX(2750);
 	 	for(int i=0;i<N_GI;i++) GI[i]->resetObj(true);
 	 	// Firewall
 	 	for(int i=0;i<N_FW;i++) FW[i]->resetObj(false);
 	 	// Insect
 	 	for(int i=0;i<N_IN;i++) IN[i]->resetObj(false);
 	 	// Fire grizzly
 	 	for(int i=0;i<N_FG;i++) FG[i]->resetObj(false);
 	 	// Clam
 	 	CL[0]->setStartX(3898); CL[0]->setStartY(578); CL[0]->setSide(0);
 	 	CL[1]->setStartX(4152); CL[1]->setStartY(500); CL[1]->setSide(1);
 	 	CL[2]->setStartX(4160); CL[2]->setStartY(548); CL[2]->setSide(1);
 	 	CL[3]->setStartX(4172); CL[3]->setStartY(387); CL[3]->setSide(0);
 	 	CL[4]->setStartX(4120); CL[4]->setStartY(226); CL[4]->setSide(1);
 	 	CL[5]->setStartX(4684); CL[5]->setStartY(300); CL[5]->setSide(1);
    CL[6]->setStartX(4712); CL[6]->setStartY(500); CL[6]->setSide(1);
    CL[7]->setStartX(4862); CL[7]->setStartY(566); CL[7]->setSide(0);
 	 	for(int i=0;i<N_CL;i++) CL[i]->resetObj(true);
 	 	
 	 	// Mobile (da 0 a 11 Magic box)
    MOBILE[0]->setStartX(740);  MOBILE[0]->setStartY(591); MOBILE[0]->setDisX(0);   MOBILE[0]->setDisY(-42); MOBILE[0]->setFGround(true);
    MOBILE[1]->setStartX(1100); MOBILE[1]->setStartY(591); MOBILE[1]->setDisX(80);  MOBILE[1]->setDisY(-48); MOBILE[1]->setFGround(true);
    MOBILE[2]->setStartX(1728); MOBILE[2]->setStartY(195); MOBILE[2]->setDisX(-99); MOBILE[2]->setDisY(-36); MOBILE[2]->setFGround(true);
    MOBILE[3]->setStartX(2990); MOBILE[3]->setStartY(195); MOBILE[3]->setDisX(-99); MOBILE[3]->setDisY(-36); MOBILE[3]->setFGround(true);
    MOBILE[4]->setStartX(3248); MOBILE[4]->setStartY(579); MOBILE[4]->setDisX(80);  MOBILE[4]->setDisY(-36); MOBILE[4]->setFGround(true);
    MOBILE[5]->setStartX(4000); MOBILE[5]->setStartY(334); MOBILE[5]->setDisX(-60); MOBILE[5]->setDisY(-36); MOBILE[5]->setFGround(true);
    MOBILE[6]->setStartX(4576); MOBILE[6]->setStartY(342); MOBILE[6]->setDisX(150); MOBILE[6]->setDisY(-36); MOBILE[6]->setFGround(true);

    MOBILE[7]->setStartX(0);    MOBILE[7]->setStartY(0);   MOBILE[7]->setDisX(0);   MOBILE[7]->setDisY(0);  MOBILE[7]->setFGround(true);
    MOBILE[8]->setStartX(0);    MOBILE[8]->setStartY(0);   MOBILE[8]->setDisX(0);   MOBILE[8]->setDisY(0);  MOBILE[8]->setFGround(true);
    MOBILE[9]->setStartX(0);    MOBILE[9]->setStartY(0);   MOBILE[9]->setDisX(0);   MOBILE[9]->setDisY(0);  MOBILE[9]->setFGround(true);
    MOBILE[10]->setStartX(0);   MOBILE[10]->setStartY(0);  MOBILE[10]->setDisX(0);  MOBILE[10]->setDisY(0); MOBILE[10]->setFGround(true);
    MOBILE[11]->setStartX(0);   MOBILE[11]->setStartY(0);  MOBILE[11]->setDisX(0);  MOBILE[11]->setDisY(0); MOBILE[11]->setFGround(true);

 	 	MOBILE[12]->setStartX(2000); MOBILE[12]->setStartY(575); MOBILE[12]->setStartFrame(25); MOBILE[12]->setEndFrame(25); MOBILE[12]->setType(0); MOBILE[12]->setFGround(true);
    MOBILE[13]->setStartX(2000); MOBILE[13]->setStartY(527); MOBILE[13]->setStartFrame(25); MOBILE[13]->setEndFrame(25); MOBILE[13]->setType(0); MOBILE[13]->setFGround(true);
    MOBILE[14]->setStartX(2000); MOBILE[14]->setStartY(479); MOBILE[14]->setStartFrame(26); MOBILE[14]->setEndFrame(26); MOBILE[14]->setType(0); MOBILE[14]->setFGround(true);
 	 	MOBILE[15]->setStartX(2672); MOBILE[15]->setStartY(575); MOBILE[15]->setStartFrame(25); MOBILE[15]->setEndFrame(25); MOBILE[15]->setType(0); MOBILE[15]->setFGround(true);
    MOBILE[16]->setStartX(2672); MOBILE[16]->setStartY(527); MOBILE[16]->setStartFrame(25); MOBILE[16]->setEndFrame(25); MOBILE[16]->setType(0); MOBILE[16]->setFGround(true);
    MOBILE[17]->setStartX(2672); MOBILE[17]->setStartY(479); MOBILE[17]->setStartFrame(26); MOBILE[17]->setEndFrame(26); MOBILE[17]->setType(0); MOBILE[17]->setFGround(true);
 	 	MOBILE[18]->setStartX(1621); MOBILE[18]->setStartY(321); MOBILE[18]->setStartFrame(25); MOBILE[18]->setEndFrame(25); MOBILE[18]->setType(0); MOBILE[18]->setFGround(true);
    MOBILE[19]->setStartX(1621); MOBILE[19]->setStartY(273); MOBILE[19]->setStartFrame(25); MOBILE[19]->setEndFrame(25); MOBILE[19]->setType(0); MOBILE[19]->setFGround(true);
    MOBILE[20]->setStartX(1621); MOBILE[20]->setStartY(225); MOBILE[20]->setStartFrame(26); MOBILE[20]->setEndFrame(26); MOBILE[20]->setType(0); MOBILE[20]->setFGround(true);
 	 	MOBILE[21]->setStartX(2224); MOBILE[21]->setStartY(321); MOBILE[21]->setStartFrame(25); MOBILE[21]->setEndFrame(25); MOBILE[21]->setType(0); MOBILE[21]->setFGround(true);
    MOBILE[22]->setStartX(2224); MOBILE[22]->setStartY(273); MOBILE[22]->setStartFrame(25); MOBILE[22]->setEndFrame(25); MOBILE[22]->setType(0); MOBILE[22]->setFGround(true);
    MOBILE[23]->setStartX(2224); MOBILE[23]->setStartY(225); MOBILE[23]->setStartFrame(26); MOBILE[23]->setEndFrame(26); MOBILE[23]->setType(0); MOBILE[23]->setFGround(true);

 	 	MOBILE[24]->setStartX(2480); MOBILE[24]->setStartY(321); MOBILE[24]->setStartFrame(25); MOBILE[24]->setEndFrame(25); MOBILE[24]->setType(0); MOBILE[24]->setFGround(true);
    MOBILE[25]->setStartX(2480); MOBILE[25]->setStartY(273); MOBILE[25]->setStartFrame(25); MOBILE[25]->setEndFrame(25); MOBILE[25]->setType(0); MOBILE[25]->setFGround(true);
    MOBILE[26]->setStartX(2480); MOBILE[26]->setStartY(225); MOBILE[26]->setStartFrame(26); MOBILE[26]->setEndFrame(26); MOBILE[26]->setType(0); MOBILE[26]->setFGround(true);

    MOBILE[27]->setStartX(1632); MOBILE[27]->setStartY(481); MOBILE[27]->setStartFrame(27); MOBILE[27]->setEndFrame(27); MOBILE[27]->setType(0); MOBILE[27]->setFGround(true);
    MOBILE[28]->setStartX(1680); MOBILE[28]->setStartY(481); MOBILE[28]->setStartFrame(28); MOBILE[28]->setEndFrame(28); MOBILE[28]->setType(0); MOBILE[28]->setFGround(true);
    MOBILE[29]->setStartX(1728); MOBILE[29]->setStartY(481); MOBILE[29]->setStartFrame(29); MOBILE[29]->setEndFrame(29); MOBILE[29]->setType(0); MOBILE[29]->setFGround(true);

    for(int i=0;i<N_PLAT;i++) MOBILE[i]->resetObj(false);
    for(int i=0;i<=6;i++)     MOBILE[i]->resetObj(true);
    for(int i=12;i<=29;i++)   MOBILE[i]->resetObj(true);
 	 	// Other
 	 	TH_SFX->resetSFX(false);
 	 	FO_SFX->resetSFX(false);
 	 	FI_SFX->resetSFX(false);
 	 	WA_SFX[0]->setStartX(0);    WA_SFX[0]->setStartY(647); WA_SFX[0]->resetSFX(true); WA_SFX[0]->setScrollSpeed(6); WA_SFX[0]->setWaveSpeed(50);
 	 	WA_SFX[1]->setStartX(3265); WA_SFX[1]->setStartY(637); WA_SFX[1]->resetSFX(true); WA_SFX[1]->setScrollSpeed(6); WA_SFX[1]->setWaveSpeed(8);  WA_SFX[1]->setWaterLen(12); WA_SFX[1]->setAlpha(200);
 	 	RA_SFX[0]->setStartX(3100); RA_SFX[0]->setStartY(516); RA_SFX[0]->resetSFX(true,0);
 	 	RA_SFX[1]->setStartX(3050); RA_SFX[1]->setStartY(516); RA_SFX[1]->resetSFX(true,1);
    for(int i=0;i<N_ZO;i++) ZO[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_SK;i++) SK[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_GI;i++) GI[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_FG;i++) FG[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_BBOX;i++) BONUSB[i]->setPlatformMap(MAP1[STAGE]);
    KEY->setPlatformMap(MAP1[STAGE]); SHILD->setPlatformMap(MAP1[STAGE]);
   }
 	if(STAGE==3)
 	 {
 	 	// Player position
 	  //if(PL->getGlobX()<3000)  { RESTART_X=130+3500;  RESTART_Y=607-260; }
 	  if(PL->getGlobX()<3000)  { RESTART_X=130;  RESTART_Y=595; }
  	if(PL->getGlobX()>=3600) { RESTART_X=3600; RESTART_Y=348; }
    PL->resetPlayer(RESTART_X,RESTART_Y);
 	 	// Blade
 	 	for(int i=0;i<N_BL;i++) BL[i]->resetObj(false);
 	 	// Zombie
 	 	for(int i=0;i<N_ZO;i++) ZO[i]->resetObj(false);
 	 	// Skeleton
 	 	for(int i=0;i<N_SK;i++) SK[i]->resetObj(false);
 	 	// Plant mk2
 	 	for(int i=0;i<N_P2;i++) P2[i]->resetObj(false);
 	 	P2[0]->setStartX(850); P2[0]->setStartY(591);
 	 	P2[1]->setStartX(1320); P2[1]->setStartY(578);
 	 	P2[2]->setStartX(2826); P2[2]->setStartY(449);
 	 	for(int i=0;i<3;i++) P2[i]->resetObj(true);
 	 	// Volture
 	 	VO[0]->setStartX(2240); VO[0]->setStartY(568);
 	 	for(int i=0;i<N_VO;i++) VO[i]->resetObj(true); 	 	
 	 	// Red arremer
 	 	for(int i=0;i<N_RA;i++) RA[i]->resetObj(false);
 	 	RA[0]->setStartX(500);  RA[0]->setStartY(591); RA[0]->resetObj(true);
 	 	RA[1]->setStartX(2600); RA[1]->setStartY(449); RA[1]->resetObj(true);
 	 	// Red arremer King
 	 	RK[0]->setStartX(3400); RK[0]->setStartY(290);
 	 	for(int i=0;i<N_RK;i++) RK[i]->resetObj(true);
 	 	RK[0]->setExitKeyP(KEY);
 	 	// Ghost
 	 	for(int i=0;i<N_GO;i++) GO[i]->resetObj(false);
 	 	// Bat
 	 	for(int i=0;i<N_BA;i++) { BA[i]->setStartX(0); BA[i]->setStartY(6000); BA[i]->resetObj(true); }
 	 	// Giant
 	 	for(int i=0;i<N_GI;i++) GI[i]->resetObj(true);
 	 	GI[0]->setStartX(1358); GI[0]->setStartY(576);
 	 	GI[1]->setStartX(2100); GI[1]->setStartY(449);
 	 	GI[2]->setStartX(3200); GI[2]->setStartY(449);
 	 	GI[3]->setStartX(2600); GI[3]->setStartY(576);
 	 	GI[4]->setStartX(3200); GI[4]->setStartY(322);
 	 	GI[5]->setStartX(2800); GI[5]->setStartY(322);
 	 	for(int i=0;i<N_GI;i++) GI[i]->resetObj(true);
 	 	// Firewall
 	 	for(int i=0;i<N_FW;i++) FW[i]->resetObj(false);
 	 	// Insect
 	 	for(int i=0;i<N_IN;i++) IN[i]->resetObj(false);
 	 	// Fire grizzly
 	 	for(int i=0;i<N_FG;i++) FG[i]->resetObj(false);
 	 	// Clam
 	 	for(int i=0;i<N_CL;i++) CL[i]->resetObj(false);
 	 	// Mobile (da 0 a 11 Magic box)
    MOBILE[0]->setStartX(200);  MOBILE[0]->setStartY(620); MOBILE[0]->setDisX(0);   MOBILE[0]->setDisY(-12); MOBILE[0]->setFGround(true);
    MOBILE[1]->setStartX(1100); MOBILE[1]->setStartY(591); MOBILE[1]->setDisX(80);  MOBILE[1]->setDisY(-48); MOBILE[1]->setFGround(true);
    MOBILE[2]->setStartX(1728); MOBILE[2]->setStartY(195); MOBILE[2]->setDisX(-99); MOBILE[2]->setDisY(-36); MOBILE[2]->setFGround(true);
    MOBILE[3]->setStartX(2990); MOBILE[3]->setStartY(195); MOBILE[3]->setDisX(-99); MOBILE[3]->setDisY(-36); MOBILE[3]->setFGround(true);
    MOBILE[4]->setStartX(330);  MOBILE[4]->setStartY(607); MOBILE[4]->setDisX(0);   MOBILE[4]->setDisY(0);   MOBILE[4]->setFGround(true);
    MOBILE[5]->setStartX(380);  MOBILE[5]->setStartY(607); MOBILE[5]->setDisX(0);   MOBILE[5]->setDisY(0);   MOBILE[5]->setFGround(true);
    MOBILE[6]->setStartX(430);  MOBILE[6]->setStartY(607); MOBILE[6]->setDisX(0);   MOBILE[6]->setDisY(0);   MOBILE[6]->setFGround(true);
    MOBILE[7]->setStartX(0);    MOBILE[7]->setStartY(0);   MOBILE[7]->setDisX(0);   MOBILE[7]->setDisY(0);   MOBILE[7]->setFGround(true);
    MOBILE[8]->setStartX(0);    MOBILE[8]->setStartY(0);   MOBILE[8]->setDisX(0);   MOBILE[8]->setDisY(0);   MOBILE[8]->setFGround(true);
    MOBILE[9]->setStartX(0);    MOBILE[9]->setStartY(0);   MOBILE[9]->setDisX(0);   MOBILE[9]->setDisY(0);   MOBILE[9]->setFGround(true);
    MOBILE[10]->setStartX(0);   MOBILE[10]->setStartY(0);  MOBILE[10]->setDisX(0);  MOBILE[10]->setDisY(0);  MOBILE[10]->setFGround(true);
    MOBILE[11]->setStartX(0);   MOBILE[11]->setStartY(0);  MOBILE[11]->setDisX(0);  MOBILE[11]->setDisY(0);  MOBILE[11]->setFGround(true);

 	 	MOBILE[12]->setStartX(538);  MOBILE[12]->setStartY(640); MOBILE[12]->setStartFrame(32); MOBILE[12]->setEndFrame(37); MOBILE[12]->setType(1); MOBILE[12]->setFGround(true);
    MOBILE[13]->setStartX(2000); MOBILE[13]->setStartY(527); MOBILE[13]->setStartFrame(25); MOBILE[13]->setEndFrame(25); MOBILE[13]->setType(0); MOBILE[13]->setFGround(true);
    MOBILE[14]->setStartX(2000); MOBILE[14]->setStartY(479); MOBILE[14]->setStartFrame(26); MOBILE[14]->setEndFrame(26); MOBILE[14]->setType(0); MOBILE[14]->setFGround(true);
 	 	MOBILE[15]->setStartX(2672); MOBILE[15]->setStartY(575); MOBILE[15]->setStartFrame(25); MOBILE[15]->setEndFrame(25); MOBILE[15]->setType(0); MOBILE[15]->setFGround(true);
    MOBILE[16]->setStartX(2672); MOBILE[16]->setStartY(527); MOBILE[16]->setStartFrame(25); MOBILE[16]->setEndFrame(25); MOBILE[16]->setType(0); MOBILE[16]->setFGround(true);
    MOBILE[17]->setStartX(2672); MOBILE[17]->setStartY(479); MOBILE[17]->setStartFrame(26); MOBILE[17]->setEndFrame(26); MOBILE[17]->setType(0); MOBILE[17]->setFGround(true);
 	 	MOBILE[18]->setStartX(1621); MOBILE[18]->setStartY(321); MOBILE[18]->setStartFrame(25); MOBILE[18]->setEndFrame(25); MOBILE[18]->setType(0); MOBILE[18]->setFGround(true);
    MOBILE[19]->setStartX(1621); MOBILE[19]->setStartY(273); MOBILE[19]->setStartFrame(25); MOBILE[19]->setEndFrame(25); MOBILE[19]->setType(0); MOBILE[19]->setFGround(true);
    MOBILE[20]->setStartX(1621); MOBILE[20]->setStartY(225); MOBILE[20]->setStartFrame(26); MOBILE[20]->setEndFrame(26); MOBILE[20]->setType(0); MOBILE[20]->setFGround(true);
 	 	MOBILE[21]->setStartX(2224); MOBILE[21]->setStartY(321); MOBILE[21]->setStartFrame(25); MOBILE[21]->setEndFrame(25); MOBILE[21]->setType(0); MOBILE[21]->setFGround(true);
    MOBILE[22]->setStartX(2224); MOBILE[22]->setStartY(273); MOBILE[22]->setStartFrame(25); MOBILE[22]->setEndFrame(25); MOBILE[22]->setType(0); MOBILE[22]->setFGround(true);
    MOBILE[23]->setStartX(2224); MOBILE[23]->setStartY(225); MOBILE[23]->setStartFrame(26); MOBILE[23]->setEndFrame(26); MOBILE[23]->setType(0); MOBILE[23]->setFGround(true);

 	 	MOBILE[24]->setStartX(2480); MOBILE[24]->setStartY(321); MOBILE[24]->setStartFrame(25); MOBILE[24]->setEndFrame(25); MOBILE[24]->setType(0); MOBILE[24]->setFGround(true);
    MOBILE[25]->setStartX(2480); MOBILE[25]->setStartY(273); MOBILE[25]->setStartFrame(25); MOBILE[25]->setEndFrame(25); MOBILE[25]->setType(0); MOBILE[25]->setFGround(true);
    MOBILE[26]->setStartX(2480); MOBILE[26]->setStartY(225); MOBILE[26]->setStartFrame(26); MOBILE[26]->setEndFrame(26); MOBILE[26]->setType(0); MOBILE[26]->setFGround(true);

    MOBILE[27]->setStartX(1632); MOBILE[27]->setStartY(481); MOBILE[27]->setStartFrame(27); MOBILE[27]->setEndFrame(27); MOBILE[27]->setType(0); MOBILE[27]->setFGround(true);
    MOBILE[28]->setStartX(1680); MOBILE[28]->setStartY(481); MOBILE[28]->setStartFrame(28); MOBILE[28]->setEndFrame(28); MOBILE[28]->setType(0); MOBILE[28]->setFGround(true);
    MOBILE[29]->setStartX(1728); MOBILE[29]->setStartY(481); MOBILE[29]->setStartFrame(29); MOBILE[29]->setEndFrame(29); MOBILE[29]->setType(0); MOBILE[29]->setFGround(true);

    for(int i=0;i<N_PLAT;i++) MOBILE[i]->resetObj(false);
    for(int i=0;i<=3;i++)     MOBILE[i]->resetObj(true);
    for(int i=12;i<=29;i++)   MOBILE[i]->resetObj(true);
 	 	// Other
 	 	TH_SFX->resetSFX(false);
 	 	FO_SFX->resetSFX(false);
 	 	FI_SFX->resetSFX(false);
 	 	WA_SFX[0]->setStartX(0);  WA_SFX[0]->setStartY(647); WA_SFX[0]->resetSFX(true); WA_SFX[0]->setScrollSpeed(6); WA_SFX[0]->setWaveSpeed(50);
 	 	WA_SFX[1]->resetSFX(false);
 	 	RA_SFX[0]->setStartX(3100); RA_SFX[0]->setStartY(516); RA_SFX[0]->resetSFX(true,0);
 	 	RA_SFX[1]->setStartX(3050); RA_SFX[1]->setStartY(516); RA_SFX[1]->resetSFX(true,1);
    for(int i=0;i<N_ZO;i++) ZO[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_SK;i++) SK[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_GI;i++) GI[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_FG;i++) FG[i]->setPlatformMap(MAP1[STAGE]);
    for(int i=0;i<N_BBOX;i++) BONUSB[i]->setPlatformMap(MAP1[STAGE]);
    KEY->setPlatformMap(MAP1[STAGE]); SHILD->setPlatformMap(MAP1[STAGE]);
   }
 }

void restartStage(int stage)
 {
 	int dress;
 	bool key_taked,shild;
 	
 	key_taked=PL->getKeyTaked(); dress=PL->getDress(); shild=PL->getShild();
 	resetObj();
 	if(key_taked) { if(dress!=1 && dress!=3) PL->setDress(dress); PL->setShild(shild); }
 	READY_GO=1;
  if(LIVES==0) { gameOver(); GAME_OVER=1; return; }
  if(!GAME_OVER) stageMap();
 }

void initObjects()
 {
 	BITMAP *back;
 	int txtcol;
 	
 	txtcol=makecol32(255,255,0);
 	drawBar(0,txtcol,SCREENX);
 	back=load_bmp("data/background.bmp",NULL);
 	stretch_blit(back,screen,0,0,640,480,0,0,SCREENX,SCREENY);
  // LOADING OBJECTS ...
  textprintf_ex(screen,font,1,12*2,txtcol,-1,"Loading Objects ..."); drawBar(5,txtcol,SCREENX);
 	// Player
 	PL=new player("data/obj/player/player.bmp",0,0,VSCR);
 	PL->setStageP(&STAGE);
 	PL->setLivesP(&LIVES);
 	PL->setScoreP(&SCORE);
 	// OSD
 	OSD=new osd("data/obj/player/osd.bmp",0,0,VSCR);
 	OSD->setLivesP(&LIVES); OSD->setScoreP(&SCORE);
 	PL->setOSD(OSD);
 	// Blades
 	BL[0]=new blade("data/obj/enemies/blade.bmp",0,0,0,0,VSCR);
 	for(int i=1;i<N_BL-1;i++) BL[i]=new blade("",0,0,0,0,VSCR,0,i,BL[0]);
 	BL[6]=new blade("",0,0,0,0,VSCR,1,6,BL[0]);
 	// Skeleton
 	SK[0]=new skeleton("data/obj/enemies/skeleton.bmp",0,0,VSCR);
 	for(int i=1;i<N_SK;i++) SK[i]=new skeleton("",0,0,VSCR,i,SK[0]);
 	// Zombie
 	ZO[0]=new zombie("data/obj/enemies/zombie.bmp",0,0,VSCR);
 	for(int i=1;i<N_ZO;i++) ZO[i]=new zombie("",0,0,VSCR,i,ZO[0]);
 	// Volture
 	VO[0]=new volture("data/obj/enemies/volture.bmp",0,0,VSCR);
 	for(int i=1;i<N_VO;i++) VO[i]=new volture("",0,0,VSCR,i,VO[0]);
 	// Red arremer
 	RA[0]=new red_arremer("data/obj/enemies/red_arremer.bmp",0,0,VSCR);
 	for(int i=1;i<N_RA;i++) RA[i]=new red_arremer("",0,0,VSCR,i,RA[0]);
 	for(int i=0;i<N_RA;i++) { RA[i]->setCtrlXP(PL->getGlobXP()); RA[i]->setCtrlYP(PL->getGlobYP()); }
 	// Red arremer King
 	RK[0]=new red_arremer_king("data/obj/enemies/red_arremer_king.bmp",0,0,VSCR);
 	for(int i=0;i<N_RK;i++) { RK[i]->setCtrlXP(PL->getGlobXP()); RK[i]->setCtrlYP(PL->getGlobYP()); }
 	// Plant mk2
 	P2[0]=new plant_mk2("data/obj/enemies/plant_mk2.bmp",0,0,VSCR);
 	for(int i=1;i<N_P2;i++) P2[i]=new plant_mk2("",0,0,VSCR,i,P2[0]);
 	for(int i=0;i<N_P2;i++) { P2[i]->setCtrlXP(PL->getGlobXP()); P2[i]->setCtrlYP(PL->getGlobYP()); }
 	// Ghost
 	GO[0]=new ghost("data/obj/enemies/ghost.bmp",0,0,VSCR);
 	for(int i=1;i<N_GO;i++) GO[i]=new ghost("",0,0,VSCR,i,GO[0]);
 	for(int i=0;i<N_GO;i++) { GO[i]->setCtrlXP(PL->getGlobXP()); GO[i]->setCtrlYP(PL->getGlobYP()); }
 	// Bat
 	BA[0]=new bat("data/obj/enemies/bat.bmp",0,0,VSCR);
 	for(int i=1;i<N_BA;i++) BA[i]=new bat("",0,0,VSCR,i,BA[0]);
 	for(int i=0;i<N_BA;i++) { BA[i]->setCtrlXP(PL->getGlobXP()); BA[i]->setCtrlYP(PL->getGlobYP()); }
 	// Giant
 	GI[0]=new giant("data/obj/enemies/giant.bmp",0,0,VSCR);
 	for(int i=1;i<N_GI;i++) GI[i]=new giant("",0,0,VSCR,i,GI[0]);
 	for(int i=0;i<N_GI;i++) { GI[i]->setCtrlXP(PL->getGlobXP()); GI[i]->setCtrlYP(PL->getGlobYP()); }
 	// Firewalls
 	FW[0]=new firewall("data/obj/enemies/firewall.bmp",0,0,0,0,VSCR);
 	for(int i=1;i<N_FW;i++) FW[i]=new firewall("",0,0,0,0,VSCR,i,FW[0]);
 	// Insect
 	IN[0]=new insect("data/obj/enemies/insect.bmp",0,0,VSCR);
 	for(int i=1;i<N_IN;i++) IN[i]=new insect("",0,0,VSCR,i,IN[0]);
 	for(int i=0;i<N_IN;i++) { IN[i]->setCtrlXP(PL->getGlobXP()); IN[i]->setCtrlYP(PL->getGlobYP()); }
 	// Fire grizzly
 	FG[0]=new fire_grizzly("data/obj/enemies/fire_grizzly.bmp",0,0,VSCR);
 	for(int i=1;i<N_FG;i++) FG[i]=new fire_grizzly("",0,0,VSCR,i,FG[0]);
 	for(int i=0;i<N_FG;i++) { FG[i]->setCtrlXP(PL->getGlobXP()); FG[i]->setCtrlYP(PL->getGlobYP()); }
 	// Clam
 	CL[0]=new clam("data/obj/enemies/clam.bmp",0,0,VSCR);
 	for(int i=1;i<N_CL;i++) CL[i]=new clam("",0,0,VSCR,i,CL[0]);
 	for(int i=0;i<N_CL;i++) { CL[i]->setCtrlXP(PL->getGlobXP()); CL[i]->setCtrlYP(PL->getGlobYP()); }

  // Mobile (da 0 a 11 Magic box)
  MOBILE=(mobile **)malloc(sizeof(mobile *)*N_PLAT);
  MOBILE[0] =new mobile("data/obj/mobile/mobile.bmp","data/obj/mobile/mobile.dat",0,0,44,49,2,VSCR);
 	MOBILE[1] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,1, MOBILE[0]);
 	MOBILE[2] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,2, MOBILE[0]);
 	MOBILE[3] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,3, MOBILE[0]);
  MOBILE[4] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,4, MOBILE[0]);
  MOBILE[5] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,5, MOBILE[0]);
  MOBILE[6] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,6, MOBILE[0]);
  MOBILE[7] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,7, MOBILE[0]);
  MOBILE[8] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,8, MOBILE[0]);
  MOBILE[9] =new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,9, MOBILE[0]);
  MOBILE[10]=new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,10,MOBILE[0]);
  MOBILE[11]=new mobile("","data/obj/mobile/mobile.dat",0,0,00,00,2,VSCR,11,MOBILE[0]);
  MOBILE[12]=new mobile("","data/obj/mobile/mobile.dat",0,0,01,01,0,VSCR,12,MOBILE[0]);
 	MOBILE[13]=new mobile("","data/obj/mobile/mobile.dat",0,0,01,01,0,VSCR,13,MOBILE[0]);
 	MOBILE[14]=new mobile("","data/obj/mobile/mobile.dat",0,0,02,02,0,VSCR,14,MOBILE[0]);
 	MOBILE[15]=new mobile("","data/obj/mobile/mobile.dat",0,0,01,01,0,VSCR,15,MOBILE[0]);
  MOBILE[16]=new mobile("","data/obj/mobile/mobile.dat",0,0,03,04,1,VSCR,16,MOBILE[0]);
  MOBILE[17]=new mobile("","data/obj/mobile/mobile.dat",0,0,03,04,1,VSCR,17,MOBILE[0]);
  MOBILE[18]=new mobile("","data/obj/mobile/mobile.dat",0,0,03,04,1,VSCR,18,MOBILE[0]);
  MOBILE[19]=new mobile("","data/obj/mobile/mobile.dat",0,0,05,05,0,VSCR,19,MOBILE[0]);
  MOBILE[20]=new mobile("","data/obj/mobile/mobile.dat",0,0,05,05,0,VSCR,20,MOBILE[0]);
  MOBILE[21]=new mobile("","data/obj/mobile/mobile.dat",0,0,05,05,0,VSCR,21,MOBILE[0]);
  MOBILE[22]=new mobile("","data/obj/mobile/mobile.dat",0,0,23,23,0,VSCR,22,MOBILE[0]);
  MOBILE[23]=new mobile("","data/obj/mobile/mobile.dat",0,0,23,23,0,VSCR,23,MOBILE[0]);
  MOBILE[24]=new mobile("","data/obj/mobile/mobile.dat",0,0,24,24,0,VSCR,24,MOBILE[0]);
  MOBILE[25]=new mobile("","data/obj/mobile/mobile.dat",0,0,22,22,0,VSCR,25,MOBILE[0]);
  MOBILE[26]=new mobile("","data/obj/mobile/mobile.dat",0,0,22,22,0,VSCR,26,MOBILE[0]);
  MOBILE[27]=new mobile("","data/obj/mobile/mobile.dat",0,0,25,25,0,VSCR,27,MOBILE[0]);
  MOBILE[28]=new mobile("","data/obj/mobile/mobile.dat",0,0,25,25,0,VSCR,28,MOBILE[0]);
  MOBILE[29]=new mobile("","data/obj/mobile/mobile.dat",0,0,26,26,0,VSCR,29,MOBILE[0]);
  for(int i=0;i<=11;i++) { MOBILE[i]->setBonusSeqP(&BONUS_SEQ); MOBILE[i]->setCtrlXP(PL->getGlobXP()); MOBILE[i]->setCtrlYP(PL->getGlobYP()); }
  // Bonus for magic box
 	BONUSB[0]=new bonus("data/obj/player/bonus.bmp",0,0,VSCR);
 	for(int i=1;i<N_BBOX;i++) BONUSB[i]=new bonus("",0,0,VSCR,0,i,BONUSB[0]);
 	KEY=new bonus("",0,0,VSCR,0,1,BONUSB[0]); // Key (next level)
 	SHILD=new bonus("",0,0,VSCR,0,1,BONUSB[0]); // Shild (when armour hitted shild is missed)

  // LOADING GRAPHIC ...
  textprintf_ex(screen,font,1,12*3,txtcol,-1,"Loading Graphic ..."); drawBar(40,txtcol,SCREENX);
 	char s1[255],s2[255],s3[255],s4[255],s5[255],s6[255],s7[255],lev[255];
 	for(int i=0;i<N_STAGE;i++)
 	 {
 	  sprintf(lev,"data/maps/l%d",i+1);
 	  sprintf(s1,"%s/map0.bmp",lev);
 	  sprintf(s2,"%s/0.map",lev);
 	  MAP0[i]=new map(s1,s2,VSCR);
 	  MAP0[i]->setCtrlXP(PL->getScrollXP()); MAP0[i]->setCtrlYP(PL->getScrollYP());
 	  MAP0[i]->setSpeedX(1); MAP0[i]->setSpeedY(1);
 	  sprintf(s1,"%s/map1.bmp",lev);
 	  sprintf(s2,"%s/1.map",lev);
 	  sprintf(s3,"%s/platform.map",lev);
 	  sprintf(s4,"%s/platform.dat",lev);
 	  sprintf(s5,"%s/stair.map",lev);
 	  sprintf(s6,"%s/wall.map",lev);
 	  sprintf(s7,"%s/wall.dat",lev);
    MAP1[i]=new map(s1,s2,VSCR,false,s3,s4,s5,s6,s7,true);
    MAP1[i]->setCtrlXP(PL->getScrollXP()); MAP1[i]->setCtrlYP(PL->getScrollYP());
    MAP1[i]->setSpeedX(2); MAP1[i]->setSpeedY(2);
    MAP1[i]->setMobileP(MOBILE,N_PLAT);
 	  sprintf(s1,"%s/maph.bmp",lev);
 	  sprintf(s2,"%s/h.map",lev);
    MAPH[i]=new map(s1,s2,VSCR,true);
    MAPH[i]->setCtrlXP(PL->getScrollXP()); MAPH[i]->setCtrlYP(PL->getScrollYP());
    MAPH[i]->setSpeedX(2); MAPH[i]->setSpeedY(2);
   }

  // LOADING SPECIAL FX ...
  textprintf_ex(screen,font,1,12*4,txtcol,-1,"Loading Special FX ..."); drawBar(80,txtcol,SCREENX);
  TH_SFX=new thunder(4802+768,520,VSCR);
  TH_SFX->loadSample("data/sound/fx/thunder.wav",0);
  TH_SFX->setCtrlXP(PL->getGlobXP()); TH_SFX->setCtrlYP(PL->getGlobYP()); 
  FO_SFX=new fog(2300,448,VSCR);
  FO_SFX->setCtrlXP(PL->getGlobXP()); FO_SFX->setCtrlYP(PL->getGlobYP()); 
  FI_SFX=new fire(2300,448,VSCR);
  FI_SFX->setCtrlXP(PL->getGlobXP()); FI_SFX->setCtrlYP(PL->getGlobYP()); 
  WA_SFX[0]=new water(2300,448,VSCR);
  WA_SFX[0]->setCtrlXP(PL->getGlobXP()); WA_SFX[0]->setCtrlYP(PL->getGlobYP()); 
  WA_SFX[1]=new water(2300,448,VSCR);
  WA_SFX[1]->setCtrlXP(PL->getGlobXP()); WA_SFX[1]->setCtrlYP(PL->getGlobYP()); 
  RA_SFX[0]=new rain(2300,400,VSCR);
  RA_SFX[0]->setCtrlXP(PL->getGlobXP()); RA_SFX[0]->setCtrlYP(PL->getGlobYP()); 
  RA_SFX[1]=new rain(2300,80,VSCR);
  RA_SFX[1]->setCtrlXP(PL->getGlobXP()); RA_SFX[1]->setCtrlYP(PL->getGlobYP()); 

  // LOADING SOUNDS ...
  textprintf_ex(screen,font,1,12*5,txtcol,-1,"Loading Sounds ..."); drawBar(90,txtcol,SCREENX);
 	PL->loadSample("data/sound/fx/throw01.wav",0);
 	PL->loadSample("data/sound/fx/land.wav",1);
 	PL->loadSample("data/sound/fx/armour01.wav",2);
 	PL->loadSample("data/sound/fx/dead.wav",3);
 	PL->loadSample("data/sound/fx/armour02.wav",4);
 	PL->loadSample("data/sound/fx/shild01.wav",5);
 	PL->loadSample("data/sound/fx/bonus.wav",6);
 	// Skeleton
 	SK[0]->loadSample("data/sound/fx/rise01.wav",0);
 	SK[0]->loadSample("data/sound/fx/kill01.wav",1);
 	for(int i=1;i<N_SK;i++) { SK[i]->assignSample(0,SK[0]); SK[i]->assignSample(1,SK[0]); }
 	// Zombie
 	ZO[0]->loadSample("data/sound/fx/rise02.wav",0);
 	ZO[0]->loadSample("data/sound/fx/kill02.wav",1);
 	for(int i=1;i<N_ZO;i++) { ZO[i]->assignSample(0,ZO[0]); ZO[i]->assignSample(1,ZO[0]); }
 	// Volture
 	VO[0]->loadSample("data/sound/fx/hit02.wav",0);
 	VO[0]->loadSample("data/sound/fx/kill04.wav",1);
 	for(int i=1;i<N_VO;i++) { VO[i]->assignSample(0,VO[0]); VO[i]->assignSample(1,VO[0]); }
 	// Blades
 	BL[0]->loadSample("data/sound/fx/blade.wav",0);
 	for(int i=1;i<N_BL;i++) BL[i]->assignSample(0,BL[0]);
 	// Red arremer
 	RA[0]->loadSample("data/sound/fx/hit01.wav",0);
 	RA[0]->loadSample("data/sound/fx/kill03.wav",1);
 	for(int i=1;i<N_RA;i++) { RA[i]->assignSample(0,RA[0]); RA[i]->assignSample(1,RA[0]); }
 	// Red arremer King
 	RK[0]->loadSample("data/sound/fx/hit02.wav",0);
 	RK[0]->loadSample("data/sound/fx/kill04.wav",1);
 	for(int i=1;i<N_RK;i++) { RK[i]->assignSample(0,RK[0]); RK[i]->assignSample(1,RK[0]); }
 	// Plant mk2
 	P2[0]->loadSample("data/sound/fx/hit02.wav",0);
 	P2[0]->loadSample("data/sound/fx/kill04.wav",1);
 	for(int i=1;i<N_P2;i++) { P2[i]->assignSample(0,P2[0]); P2[i]->assignSample(1,P2[0]); } 
 	// Ghost
 	GO[0]->loadSample("data/sound/fx/hit02.wav",0);
 	GO[0]->loadSample("data/sound/fx/kill04.wav",1);
 	for(int i=1;i<N_GO;i++) { GO[i]->assignSample(0,GO[0]); GO[i]->assignSample(1,GO[0]); } 
 	// Bat
 	BA[0]->loadSample("data/sound/fx/hit02.wav",0);
 	BA[0]->loadSample("data/sound/fx/kill02.wav",1);
 	for(int i=1;i<N_BA;i++) { BA[i]->assignSample(0,BA[0]); BA[i]->assignSample(1,BA[0]); } 
 	// Giant
 	GI[0]->loadSample("data/sound/fx/hit01.wav",0);
 	GI[0]->loadSample("data/sound/fx/kill03.wav",1);
 	GI[0]->loadSample("data/sound/fx/step.wav",2);
 	for(int i=1;i<N_GI;i++) { GI[i]->assignSample(0,GI[0]); GI[i]->assignSample(1,GI[0]); GI[i]->assignSample(2,GI[0]); } 
 	// Firewall
 	FW[0]->loadSample("data/sound/fx/fireup.wav",0);
 	for(int i=1;i<N_FW;i++) FW[i]->assignSample(0,FW[0]);
 	// Insect
 	IN[0]->loadSample("data/sound/fx/hit02.wav",0);
 	IN[0]->loadSample("data/sound/fx/kill04.wav",1);
 	for(int i=1;i<N_IN;i++) { IN[i]->assignSample(0,IN[0]); IN[i]->assignSample(1,IN[0]); } 
 	// Fire grizzly
 	FG[0]->loadSample("data/sound/fx/hit01.wav",0);
 	FG[0]->loadSample("data/sound/fx/kill03.wav",1);
 	FG[0]->loadSample("data/sound/fx/step.wav",2);
 	for(int i=1;i<N_FG;i++) { FG[i]->assignSample(0,FG[0]); FG[i]->assignSample(1,FG[0]); FG[i]->assignSample(2,FG[0]); } 
 	// Clam
 	CL[0]->loadSample("data/sound/fx/hit02.wav",0);
 	CL[0]->loadSample("data/sound/fx/kill04.wav",1);
 	for(int i=1;i<N_CL;i++) { CL[i]->assignSample(0,CL[0]); CL[i]->assignSample(1,CL[0]); } 
 	
 	// Bonus for magic box
 	BONUSB[0]->loadSample("data/sound/fx/blade.wav",0);
	for(int i=1;i<N_BBOX;i++) BONUSB[i]->assignSample(0,BONUSB[0]);
	KEY->assignSample(0,BONUSB[0]);
	SHILD->assignSample(0,BONUSB[0]);

  music[0]=load_midi("data/sound/music/l1.mid");
  music[1]=load_midi("data/sound/music/l2.mid");
  music[2]=load_midi("data/sound/music/l3.mid");
  music[3]=load_midi("data/sound/music/l4.mid");
  /*music[4]=load_midi("data/sound/music/l5.mid");*/
  
  drawBar(100,txtcol,SCREENX);
  destroy_bitmap(back);
 }

void readConf(int *screenres,bool *fscreen, bool *stretch,bool *debug)
 {
 	FILE *fd;
 	char dummy[50];
 	int aux;
 	
 	fd=fopen(CFGFILE,"r");
 	if(fd)
 	 {
    fscanf(fd,"%s%d",dummy,screenres);
    fscanf(fd,"%s%d",dummy,&aux); if(aux==0) *fscreen=false; else *fscreen=true;
    fscanf(fd,"%s%d",dummy,&aux); if(aux==0) *stretch=false; else *stretch=true;
    fscanf(fd,"%s%d",dummy,&aux); if(aux==0) *debug=false;   else *debug=true;
 	 	fclose(fd);
 	 }
 	else writeConf(*screenres,*fscreen,*stretch,*debug);
 }
 
void writeConf(int screenres, bool fscreen, bool stretch, bool debug)
 {
 	FILE *fd;
 	
 	fd=fopen(CFGFILE,"w");
 	fprintf(fd,"[screenres]\n%d",screenres);
 	fprintf(fd,"\n[fscreen]\n%d",fscreen);
 	fprintf(fd,"\n[stretch]\n%d",stretch);
 	fprintf(fd,"\n[debug]\n%d",debug);
 	fclose(fd);
 }

void checkGame()
 {
 	readyGo();
 	if(STAGE==0)
 	 {
 	 	if(PL->getGlobX()<3600+768)
 	 	 {
 	 	 	// Vscroll off
 	 	 	PL->setScrollCenterY(2);
 	 	 	MAP1[0]->setVScroll(false,448);
 	 	 	MAP0[0]->setVScroll(false,448/2);
 	 	 	MAPH[0]->setVScroll(false,448);
 	 	 }
 	 	else
 	 	 {
 	 	 	// Vscroll on
 	 	 	PL->setScrollCenterY(106);
 	 	 	MAP1[0]->setVScroll(true);
 	 	 	MAP0[0]->setVScroll(true);
 	 	 	MAPH[0]->setVScroll(true);
 	 	 }
 	 }
 	if(STAGE==1)
 	 {
 	 	//if(PL->getGlobX()<5586) //3800
 	 	 {
 	 	 	// Vscroll on
 	 	 	PL->setScrollCenterY(130);
 	 	 	MAP1[1]->setVScroll(true);
 	 	 	MAP0[1]->setVScroll(true);
 	 	 	MAPH[1]->setVScroll(true);
 	 	 }
 	 	/*else
 	 	 {
 	 	 	// Vscroll off
 	 	 	// ???
 	 	 	PL->setScrollCenterY(2);
 	 	 	MAP1[1]->setVScroll(false,448);
 	 	 	MAP0[1]->setVScroll(false,448/2);
 	 	 	MAPH[1]->setVScroll(false,448);
 	 	 }*/
 	 }
 	if(STAGE==2)
 	 {
 	 	//if(PL->getGlobX()<3800)
 	 	 {
 	 	 	// Vscroll on
 	 	 	PL->setScrollCenterY(130);
 	 	 	MAP1[1]->setVScroll(true);
 	 	 	MAP0[1]->setVScroll(true);
 	 	 	MAPH[1]->setVScroll(true);
 	 	 }
 	 	//else
 	 	 {
 	 	 	// Vscroll off
 	 	 	// ???
 	 	 	/*PL->setScrollCenterY(2);
 	 	 	MAP1[1]->setVScroll(false,224);
 	 	 	MAP0[1]->setVScroll(false,224/2);
 	 	 	MAPH[1]->setVScroll(false,224);*/
 	 	 }
 	 }
 	if(STAGE==3)
 	 {
 	 	if(PL->getGlobX()<3600+768)
 	 	 {
 	 	 	// Vscroll off
 	 	 	PL->setScrollCenterY(2);
 	 	 	MAP1[0]->setVScroll(false,448);
 	 	 	MAP0[0]->setVScroll(false,448/2);
 	 	 	MAPH[0]->setVScroll(false,448);
 	 	 }
 	 	else
 	 	 {
 	 	 	// Vscroll on
 	 	 	PL->setScrollCenterY(106);
 	 	 	MAP1[0]->setVScroll(true);
 	 	 	MAP0[0]->setVScroll(true);
 	 	 	MAPH[0]->setVScroll(true);
 	 	 }
 	 }
 }

void readyGo()
 {
 	if(READY_GO>0)
 	 {
 	 	READY_GO--;
 	 	if(READY_GO==0)
 	 	 {
 	 	 	stop_midi();
 	 	  if(L_B)   layer_back();
 	 	  if(L_0)   layer_0();
 	 	  if(L_1)   layer_1();
 	 	  if(L_S)   layer_s();
 	 	  if(L_H)   layer_h();
 	 	  if(L_OSD) layer_OSD(50);
 	 	  Player();
 	 	  Scroll();
 	 	 	textprintf_ex(VSCR,font,144,106,makecol32(255,0,0),-1,"Ready Go");
 	 	 	rePaint(MFPS);
      wait(1500);
      play_midi(music[STAGE],1);
     }
 	 }
 }

void gameOver()
 {
 	clear_to_color(VSCR,makecol(0,0,0));
 	if(L_B)   layer_back();
 	if(L_0)   layer_0();
 	if(L_1)   layer_1();
 	if(L_H)   layer_h();
 	if(L_OSD) layer_OSD(50);
 	textprintf_ex(VSCR,font,150,106,makecol32(255,0,0),-1,"GAME OVER");
 	rePaint(MFPS);
  wait(2500);
 }

void Intro()
 {
 	BITMAP *tit;
 	MIDI *intro_music;

 	tit=load_bmp("data/competition.bmp",NULL);
 	intro_music=load_midi("data/sound/music/l5.mid");
 	play_midi(intro_music,0);
 	stretch_blit(tit,screen,0,0,640,480,0,0,SCREENX,SCREENY);
 	textprintf_ex(screen,font,(SCREENX-8*12)>>1,SCREENY-24,makecol32(50,50,50),-1,"press any key...");
 	clear_keybuf(); while(!keypressed());
 	for(int i=0;i<FADETIME;i++)
 	 {
 	 	fade32(tit);
 	 	stretch_blit(tit,screen,0,0,640,480,0,0,SCREENX,SCREENY);
 	 	vsync();
 	 }
 	clear_to_color(screen,makecol(0,0,0));
 	destroy_bitmap(tit); destroy_midi(intro_music);
 	if(key[KEY_ESC]) exit(0);
 }

void Title()
 {
 	BITMAP *tit,*art;
 	MIDI *intro_music;
 	int POS;
 	int stage,menu,screenres;
 	bool fscreen,stretch,debug;
 	
 	POS=0;
 	stage=0;
 	menu=0;
 	readConf(&screenres,&fscreen,&stretch,&debug);
 	tit=load_bmp("data/title.bmp",NULL);
 	art=load_bmp("data/arthur.bmp",NULL);
 	intro_music=load_midi("data/sound/music/l5.mid");
 	play_midi(intro_music,0);
 	clear_keybuf();
 	while(1)
 	 {
 	  blit(tit,VSCR,0,0,0,0,G_RESX,G_RESY);
    if(menu==0)
     {
      textprintf_ex(VSCR,font,1,204,makecol32(255,0,0),-1,"2006 www.valarsoft.com/ramuso (allegro section) - \"www.valarsoft.com\"");
      textprintf_ex(VSCR,font,1,216,makecol32(255,0,0),-1,"Made with allegro library");
      textprintf_ex(VSCR,font,328,216,makecol32(255,0,0),-1,"V. %s",VER);

      textprintf_ex(VSCR,font,155,165+12*0,makecol32(255,255,0),-1,"Options >>> ");
      textprintf_ex(VSCR,font,155,165+12*1,makecol32(255,255,0),-1,"Start game  ");
      textprintf_ex(VSCR,font,155,165+12*2,makecol32(255,255,0),-1,"Exit        ");
  	 	draw_sprite(VSCR,art,136,162+POS*12);
  	 	if(key[KEY_DOWN]) { if(POS<2) POS++; key[KEY_DOWN]=false; }
 	  	if(key[KEY_UP])   { if(POS>0) POS--; key[KEY_UP]=false; }
 	  	if(key[KEY_SPACE] || key[KEY_ENTER] || key[KEY_LCONTROL] || key[KEY_ALT] || POS==0)
 	 	   {
 	 	 	  if(POS==0) {
 	 	 		            if(key[KEY_RIGHT]) { menu=1; }
 	 	 		            key[KEY_RIGHT]=false;
 	 	 		           }
 	 	 	  if(POS==1) break;
 	 	 	  if(POS==2) { destroy_bitmap(tit);destroy_bitmap(art); destroy_midi(intro_music); exit(0); }
 	 	   }
     }
    if(menu==1)
     {
     	textprintf_ex(VSCR,font,1,165+12*3,makecol32(255,0,0),-1,"You must restart");
     	textprintf_ex(VSCR,font,1,165+12*4,makecol32(255,0,0),-1,"to apply changes");
     	
      textprintf_ex(VSCR,font,155,165+12*0,makecol32(255,255,0),-1,"<<< Back    ");
                       textprintf_ex(VSCR,font,155,165+12*1,makecol32(255,255,0),-1,"Starting stage: 0%d   ",stage+1);
      if(screenres==0) textprintf_ex(VSCR,font,155,165+12*2,makecol32(255,255,0),-1,"Video:          320x200");
      if(screenres==1) textprintf_ex(VSCR,font,155,165+12*2,makecol32(255,255,0),-1,"Video:          320x240");
      if(screenres==2) textprintf_ex(VSCR,font,155,165+12*2,makecol32(255,255,0),-1,"Video:          384x224");
      if(screenres==3) textprintf_ex(VSCR,font,155,165+12*2,makecol32(255,255,0),-1,"Video:          400x300");
      if(screenres==4) textprintf_ex(VSCR,font,155,165+12*2,makecol32(255,255,0),-1,"Video:          512x384");
      if(screenres==5) textprintf_ex(VSCR,font,155,165+12*2,makecol32(255,255,0),-1,"Video:          640x480");
      if(screenres==6) textprintf_ex(VSCR,font,155,165+12*2,makecol32(255,255,0),-1,"Video:          768x448");
      if(fscreen)      textprintf_ex(VSCR,font,155,165+12*3,makecol32(255,255,0),-1,"Fullscreen:     On");
      else             textprintf_ex(VSCR,font,155,165+12*3,makecol32(255,255,0),-1,"Fullscreen:     Off");
      if(stretch)      textprintf_ex(VSCR,font,155,165+12*4,makecol32(255,255,0),-1,"Fit resolution: On");
      else             textprintf_ex(VSCR,font,155,165+12*4,makecol32(255,255,0),-1,"Fit resolution: Off");
  	 	draw_sprite(VSCR,art,136,162+POS*12);
  	 	if(key[KEY_DOWN]) { if(POS<4) POS++; key[KEY_DOWN]=false; }
 	  	if(key[KEY_UP])   { if(POS>0) POS--; key[KEY_UP]=false; }
 	  	if(key[KEY_ESC] || key[KEY_SPACE] || key[KEY_ENTER] || key[KEY_LCONTROL] || key[KEY_ALT] || POS==0 || POS==1 || POS==2 || POS==3 || POS==4)
 	 	   {
 	 	 	  //if(key[KEY_ESC]) { menu=0; key[KEY_ESC]=false; POS=0; stage=0; }
 	 	 	  if(POS==0) { 
 	 	 	  	 	 	 		  if(key[KEY_LEFT]) menu=0;
 	 	 		            key[KEY_LEFT]=false;
                    writeConf(screenres,fscreen,stretch,debug);
 	 	 		           }
 	 	 	  if(POS==1) {
 	 	 		            if(key[KEY_LEFT])  { if(stage>0)         stage--; }
 	 	 		            if(key[KEY_RIGHT]) { if(stage<N_STAGE-1) stage++; }
 	 	 		            key[KEY_LEFT]=false; key[KEY_RIGHT]=false;
 	 	 		           }
 	 	 	  if(POS==2) {
 	 	 		            if(key[KEY_LEFT])  { if(screenres>0) screenres--; }
 	 	 		            if(key[KEY_RIGHT]) { if(screenres<6) screenres++; }
 	 	 		            key[KEY_LEFT]=false; key[KEY_RIGHT]=false;
 	 	 		           }
 	 	 	  if(POS==3) {
 	 	 		            if(key[KEY_LEFT])  { if(fscreen)  fscreen=false; }
 	 	 		            if(key[KEY_RIGHT]) { if(!fscreen) fscreen=true; }
 	 	 		            key[KEY_LEFT]=false; key[KEY_RIGHT]=false;
 	 	 		           }
 	 	 	  if(POS==4) {
 	 	 		            if(key[KEY_LEFT])  { if(stretch)  stretch=false; }
 	 	 		            if(key[KEY_RIGHT]) { if(!stretch) stretch=true; }
 	 	 		            key[KEY_LEFT]=false; key[KEY_RIGHT]=false;
 	 	 		           }
 	 	   }
 	 	 }
 	 	rePaint(MFPS);
 	 }
 	 for(int i=0;i<FADETIME;i++)
 	  {
 	 	 fade32(tit);
 	 	 blit(tit,VSCR,0,0,0,0,G_RESX,G_RESY);
 	 	 rePaint(MFPS);
 	  }
 	destroy_bitmap(tit); destroy_bitmap(art); destroy_midi(intro_music);
 	clear_to_color(screen,makecol(0,0,0));
 	initGame(stage);
 }

void stageMap()
 {
 	BITMAP *smap;
 	SAMPLE *jingle;
 	int pos;
 	
 	pos=0;
 	stop_midi();
 	jingle=load_sample("data/sound/fx/stagemap.wav");
 	smap=load_bmp("data/stagemap.bmp",NULL);
 	play_sample(jingle,120,150,1000,0);
 	blit(smap,VSCR,0,0,0,0,G_RESX,G_RESY); rePaint(MFPS);
 	clear_keybuf(); wait(500);
 	while(pos<305 && !key[KEY_LCONTROL] && !key[KEY_ALT] && !key[KEY_SPACE] && !key[KEY_ESC])
 	 {
 	  blit(smap,VSCR,pos,0,0,0,G_RESX,G_RESY);
 	 	rePaint(MFPS);
 	 	pos++;
 	 }
 	if(!key[KEY_LCONTROL] && !key[KEY_ALT] && !key[KEY_SPACE] && !key[KEY_ESC]) wait(1500);
 	for(int i=0;i<FADETIME;i++)
 	 {
 	 	fade32(smap);
 	 	blit(smap,VSCR,pos,0,0,0,G_RESX,G_RESY);
 	 	rePaint(MFPS);
 	 }
 	clear_to_color(screen,makecol(0,0,0));
 	destroy_sample(jingle); destroy_bitmap(smap); clear_keybuf();
 	key[KEY_LCONTROL]=0; key[KEY_ALT]=0; key[KEY_SPACE]=0; key[KEY_ESC]=0;
 }

void layer_back()
 {
 	clear_to_color(VSCR,makecol(0,0,0));
 	TH_SFX->timeSFX(); TH_SFX->animSFX();	TH_SFX->drawSFX(0,0);
 }

void layer_0() { MAP0[STAGE]->drawMap(); }

void layer_1()
 {
  for(int i=0;i<N_PLAT;i++) if(!MOBILE[i]->getFGround()) MOBILE[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	RA_SFX[0]->timeSFX(); RA_SFX[0]->animSFX();	RA_SFX[0]->drawSFX(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	MAP1[STAGE]->drawMap();
 }

void layer_s() 
 {
 	for(int i=0;i<N_BL;i++) BL[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_ZO;i++) ZO[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_SK;i++) SK[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_VO;i++) VO[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_RA;i++) RA[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_RK;i++) RK[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_P2;i++) P2[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_GO;i++) GO[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_BA;i++) BA[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_GI;i++) GI[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_FW;i++) FW[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_IN;i++) IN[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_FG;i++) FG[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<N_CL;i++) CL[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	
 	for(int i=0;i<N_BBOX;i++) BONUSB[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	SHILD->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	KEY->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	PL->drawSprite();
 	for(int i=0;i<N_PLAT;i++) if(MOBILE[i]->getFGround()) MOBILE[i]->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	for(int i=0;i<PL->getNWeapon();i++) PL->getWeapon(i)->drawSprite(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 }

void layer_h()
 {
 	MAPH[STAGE]->drawMap();
 	RA_SFX[1]->timeSFX(); RA_SFX[1]->animSFX();	RA_SFX[1]->drawSFX(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	WA_SFX[0]->timeSFX(); WA_SFX[0]->animSFX();	WA_SFX[0]->drawSFX(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	WA_SFX[1]->timeSFX(); WA_SFX[1]->animSFX();	WA_SFX[1]->drawSFX(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	FO_SFX->timeSFX(); FO_SFX->animSFX();	FO_SFX->drawSFX(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	FI_SFX->timeSFX(); FI_SFX->animSFX();	FI_SFX->drawSFX(MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 }

void layer_OSD(int alpha)
 {
 	OSD->drawOSD(0,0);
  // 	set_trans_blender(0,0,0,alpha);
 	rect(VSCR,2,270,256,276,makecol32(255,255,255));
 	/*if(e>0) rectfill(VSCR,4,472,4+e,474,makecol32(255-e,e,0));
 	set_trans_blender(0,0,0,255);
 	//draw_trans_sprite(VSCR,ammo1,10,100);
 	PL1->putCursor(0);
 	for(int i=0;i<N_VE;i++) VE[i]->putEnergy(alpha);*/
 }

void Player()
 {
 	for(int i=0;i<PL->getNWeapon();i++) // Weapons
 	{
 	 PL->getWeapon(i)->timeSprite();
 	 PL->getWeapon(i)->animSprite();
 	}
 	PL->timeSprite();
 	PL->animSprite();
 	PL->moveSprite();
 	PL->platformSprite();
 	if(PL->getReadyGo()) restartStage(STAGE);
 }

void Enemies()
 {
 	for(int i=0;i<N_ZO;i++) { ZO[i]->timeSprite(); ZO[i]->animSprite(); ZO[i]->platformSprite(); }
  for(int i=0;i<N_SK;i++) { SK[i]->timeSprite(); SK[i]->animSprite(); SK[i]->platformSprite(); }
  for(int i=0;i<N_VO;i++) { VO[i]->timeSprite(); VO[i]->animSprite(); /*VO[i]->platformSprite();*/ }
  for(int i=0;i<N_BL;i++) { BL[i]->timeSprite(); BL[i]->animSprite(); /*BL[i]->platformSprite();*/ }
  for(int i=0;i<N_RA;i++) { RA[i]->timeSprite(); RA[i]->animSprite(); /*RA[i]->platformSprite();*/ }
  for(int i=0;i<N_RK;i++) { RK[i]->timeSprite(); RK[i]->animSprite(); /*RK[i]->platformSprite();*/ }
  for(int i=0;i<N_P2;i++) { P2[i]->timeSprite(); P2[i]->animSprite(); /*P2[i]->platformSprite();*/ }
  for(int i=0;i<N_GO;i++) { GO[i]->timeSprite(); GO[i]->animSprite(); /*GO[i]->platformSprite();*/ }
  for(int i=0;i<N_BA;i++) { BA[i]->timeSprite(); BA[i]->animSprite(); /*BA[i]->platformSprite();*/ }
  for(int i=0;i<N_GI;i++) { GI[i]->timeSprite(); GI[i]->animSprite(); GI[i]->platformSprite(); }
  for(int i=0;i<N_FW;i++) { FW[i]->timeSprite(); FW[i]->animSprite(); /*FW[i]->platformSprite();*/ }
  for(int i=0;i<N_IN;i++) { IN[i]->timeSprite(); IN[i]->animSprite(); /*IN[i]->platformSprite();*/ }
  for(int i=0;i<N_FG;i++) { FG[i]->timeSprite(); FG[i]->animSprite(); FG[i]->platformSprite(); }
  for(int i=0;i<N_CL;i++) { CL[i]->timeSprite(); CL[i]->animSprite(); /*CL[i]->platformSprite();*/ }

  for(int i=0;i<N_BBOX;i++) { BONUSB[i]->timeSprite(); BONUSB[i]->animSprite(); BONUSB[i]->platformSprite(); }
  SHILD->timeSprite(); SHILD->animSprite(); SHILD->platformSprite();
  KEY->timeSprite(); KEY->animSprite(); KEY->platformSprite();
  for(int i=0;i<N_PLAT;i++) { MOBILE[i]->timeSprite(); MOBILE[i]->animSprite(); /*MOBILE[i]->platformSprite();*/ }
 }

void Scroll()
 {
 	MAP0[STAGE]->scrollMap();
  MAP1[STAGE]->scrollMap();
 	MAPH[STAGE]->scrollMap();
 }

void Collision()
 {
 	collisionPlayerBonus();
 	collisionShildBullets();
 	collisionWeaponEnemies();
 	collisionPlayerEnemies();
 	collisionPlayerBullets();
 }

void collisionPlayerBonus()
 {
 	// Player con bonus
  for(int i=0;i<N_BBOX;i++) // Bonus for magic box
   {
   	if(BONUSB[i]->isActive() && !BONUSB[i]->isTaked() && PL->getDress()!=3)
     if(hitTestFast8(PL->getActFrameColP(),BONUSB[i]->getActFrameColP(),PL->getX(),PL->getY(),BONUSB[i]->getPosX(),BONUSB[i]->getPosY()))
      if(BONUSB[i]->getType()!=6) { PL->takeBonus(BONUSB[i]->getType(),BONUSB[i]->getExtra()); if(BONUSB[i]->getType()==4) BONUSB[i]->setTaked(true); else BONUSB[i]->resetObj(false); }
      else if(PL->isHittable()) PL->setHitted(true);
   }
  if(SHILD->isActive() && PL->getDress()!=3) // Shild (when missed)
   if(hitTestFast8(PL->getActFrameColP(),SHILD->getActFrameColP(),PL->getX(),PL->getY(),SHILD->getPosX(),SHILD->getPosY()))
    { PL->takeBonus(SHILD->getType()); SHILD->resetObj(false); }
  if(KEY->isActive() && PL->getDress()!=3) // Key (next level)
   if(hitTestFast8(PL->getActFrameColP(),KEY->getActFrameColP(),PL->getX(),PL->getY(),KEY->getPosX(),KEY->getPosY()))
    { PL->takeBonus(KEY->getType()); KEY->resetObj(false); }
 }

void collisionShildBullets()
 {
 	// Shild con bullets
 	if(PL->getShild() && PL->isHittable() && !PL->isGold())
 	 {
    for(int i=0;i<N_P2;i++) // Plant mk2 bullets
     {
   	  for(int j=0;j<P2[i]->getNBullet();j++)
   	   if(P2[i]->getBullet(j)->isFired() && P2[i]->getBullet(j)->canHit())
   	    if(hitTestFast8(P2[i]->getBullet(j)->getActFrameColP(),PL->getActFrameColP(true),P2[i]->getBullet(j)->getX(),P2[i]->getBullet(j)->getY(),PL->getX(),PL->getY(),3,0,0))
         { PL->setShildHit(true); P2[i]->getBullet(j)->hit(); return; }
     }
    for(int i=0;i<N_GI;i++) // Giant bullets
     {
   	  for(int j=0;j<GI[i]->getNBullet();j++)
   	   if(GI[i]->getBullet(j)->isFired() && GI[i]->getBullet(j)->canHit())
   	    if(hitTestFast8(GI[i]->getBullet(j)->getActFrameColP(),PL->getActFrameColP(true),GI[i]->getBullet(j)->getX(),GI[i]->getBullet(j)->getY(),PL->getX(),PL->getY(),3,0,0))
         { PL->setShildHit(true); GI[i]->getBullet(j)->hit(); return; }
     }
    for(int i=0;i<N_GI;i++) // Fire grizzly bullets
     {    	
   	  for(int j=0;j<FG[i]->getNBullet();j++)
   	   if(FG[i]->getBullet(j)->isFired() && FG[i]->getBullet(j)->canHit())
   	    if(hitTestFast8(FG[i]->getBullet(j)->getActFrameColP(),PL->getActFrameColP(true),FG[i]->getBullet(j)->getX(),FG[i]->getBullet(j)->getY(),PL->getX(),PL->getY(),3,0,0))
         { PL->setShildHit(true); FG[i]->getBullet(j)->hit(); return; }
     }
    for(int i=0;i<N_CL;i++) // Clam bullets
     {
   	  for(int j=0;j<CL[i]->getNBullet();j++)
   	   if(CL[i]->getBullet(j)->isFired() && CL[i]->getBullet(j)->canHit())
   	    if(hitTestFast8(CL[i]->getBullet(j)->getActFrameColP(),PL->getActFrameColP(true),CL[i]->getBullet(j)->getX(),CL[i]->getBullet(j)->getY(),PL->getX(),PL->getY(),3,0,0))
         { PL->setShildHit(true); CL[i]->getBullet(j)->hit(); return; }
     }
   }
 }

void collisionPlayerEnemies()
 {
 	// Player con enemies
 	if(PL->isHittable() && !PL->isGold())
 	 {
 	  for(int i=0;i<N_BL;i++) // Blade
 	   {
 	   	if(BL[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),BL[i]->getActFrameColP(),PL->getX(),PL->getY(),BL[i]->getPosX(),BL[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_SK;i++) // Skeleton
 	   {
 	   	if(SK[i]->canHit() && SK[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),SK[i]->getActFrameColP(),PL->getX(),PL->getY(),SK[i]->getPosX(),SK[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_ZO;i++) // Zombie
 	   {
 	   	if(ZO[i]->canHit() && ZO[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),ZO[i]->getActFrameColP(),PL->getX(),PL->getY(),ZO[i]->getPosX(),ZO[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_VO;i++) // Volture
 	   {
 	   	if(VO[i]->canHit() && VO[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),VO[i]->getActFrameColP(),PL->getX(),PL->getY(),VO[i]->getPosX(),VO[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_RA;i++) // Red Arremer
 	   {
 	   	if(RA[i]->canHit() && RA[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),RA[i]->getActFrameColP(),PL->getX(),PL->getY(),RA[i]->getPosX(),RA[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_RK;i++) // Red Arremer King
 	   {
 	   	if(RK[i]->canHit() && RK[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),RK[i]->getActFrameColP(),PL->getX(),PL->getY(),RK[i]->getPosX(),RK[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_P2;i++) // Plant mk2
 	   {
 	   	if(P2[i]->canHit() && P2[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),P2[i]->getActFrameColP(),PL->getX(),PL->getY(),P2[i]->getPosX(),P2[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_GO;i++) // Ghost
 	   {
 	   	if(GO[i]->canHit() && GO[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),GO[i]->getActFrameColP(),PL->getX(),PL->getY(),GO[i]->getPosX(),GO[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_BA;i++) // Bat
 	   {
 	   	if(BA[i]->canHit() && BA[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),BA[i]->getActFrameColP(),PL->getX(),PL->getY(),BA[i]->getPosX(),BA[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_GI;i++) // Giant
 	   {
 	   	if(GI[i]->canHit() && GI[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),GI[i]->getActFrameColP(),PL->getX(),PL->getY(),GI[i]->getPosX(),GI[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_FW;i++) // Firewall
 	   {
 	   	if(FW[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),FW[i]->getActFrameColP(),PL->getX(),PL->getY(),FW[i]->getPosX(),FW[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_IN;i++) // Insect
 	   {
 	   	if(IN[i]->canHit() && IN[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),IN[i]->getActFrameColP(),PL->getX(),PL->getY(),IN[i]->getPosX(),IN[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_FG;i++) // Fire grizzly
 	   {
 	   	if(FG[i]->canHit() && FG[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),FG[i]->getActFrameColP(),PL->getX(),PL->getY(),FG[i]->getPosX(),FG[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	  for(int i=0;i<N_CL;i++) // Clam
 	   {
 	   	if(CL[i]->canHit() && CL[i]->isActive())
 	     if(hitTestFast8(PL->getActFrameColP(),CL[i]->getActFrameColP(),PL->getX(),PL->getY(),CL[i]->getPosX(),CL[i]->getPosY()))
 	      PL->setHitted(true);
 	   }
 	 }
 }

void collisionWeaponEnemies()
 {
 	// Weapon con enemies
 	for(int j=0;j<PL->getNWeapon();j++)
 	 {
 	  if(PL->getWeapon(j)->isFired() && PL->getWeapon(j)->canHit())
 	   {
 	    for(int i=0;i<N_SK;i++) // Skeleton
 	     {
 	     	if(SK[i]->isHittable() && SK[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),SK[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),SK[i]->getPosX(),SK[i]->getPosY(),4,0,0))
 	        { SK[i]->setHitted(true); SCORE+=SK[i]->getScore(); PL->getWeapon(j)->hit(); return; }
 	     }
 	    for(int i=0;i<N_ZO;i++) // Zombie
 	     {
 	     	if(ZO[i]->isHittable() && ZO[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),ZO[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),ZO[i]->getPosX(),ZO[i]->getPosY(),4,0,0))
 	        { ZO[i]->setHitted(true); SCORE+=ZO[i]->getScore(); PL->getWeapon(j)->hit(); return; }
 	     }
 	    for(int i=0;i<N_BL;i++) // Blade
 	     {
 	     	if(BL[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),BL[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),BL[i]->getPosX(),BL[i]->getPosY(),4,0,0))
 	        { PL->getWeapon(j)->hitHard(); return; }
 	     }
 	    for(int i=0;i<N_VO;i++) // Volture
 	     {
 	     	if(VO[i]->isHittable() && VO[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),VO[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),VO[i]->getPosX(),VO[i]->getPosY(),4,0,0))
 	        { VO[i]->setHitted(true); SCORE+=VO[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_RA;i++) // Red arremer
 	     {
 	     	if(RA[i]->isHittable() && RA[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),RA[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),RA[i]->getPosX(),RA[i]->getPosY(),4,0,0))
 	        { RA[i]->setHitted(true); SCORE+=RA[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_RK;i++) // Red arremer King
 	     {
 	     	if(RK[i]->isHittable() && RK[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),RK[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),RK[i]->getPosX(),RK[i]->getPosY(),4,0,0))
 	        { RK[i]->setHitted(true); SCORE+=RK[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_P2;i++) // Plant mk2
 	     {
 	     	if(P2[i]->isHittable() && P2[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),P2[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),P2[i]->getPosX(),P2[i]->getPosY(),4,0,0))
 	        { P2[i]->setHitted(true); SCORE+=P2[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_GO;i++) // Ghost
 	     {
 	     	if(GO[i]->isHittable() && GO[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),GO[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),GO[i]->getPosX(),GO[i]->getPosY(),4,0,0))
 	        { GO[i]->setHitted(true); SCORE+=GO[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_BA;i++) // Bat
 	     {
 	     	if(BA[i]->isHittable() && BA[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),BA[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),BA[i]->getPosX(),BA[i]->getPosY(),4,0,0))
 	        { BA[i]->setHitted(true); SCORE+=BA[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_GI;i++) // Giant
 	     {
 	     	if(GI[i]->isHittable() && GI[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),GI[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),GI[i]->getPosX(),GI[i]->getPosY(),4,0,0))
 	        { GI[i]->setHitted(true); SCORE+=GI[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_FW;i++) // Firewall
 	     {
 	     	if(FW[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),FW[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),FW[i]->getPosX(),FW[i]->getPosY(),4,0,10))
 	        { PL->getWeapon(j)->hitHard(); return; }
 	     }
 	    for(int i=0;i<N_IN;i++) // Insect
 	     {
 	     	if(IN[i]->isHittable() && IN[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),IN[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),IN[i]->getPosX(),IN[i]->getPosY(),4,0,0))
 	        { IN[i]->setHitted(true); SCORE+=IN[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_FG;i++) // Fire grizzly
 	     {
 	     	if(FG[i]->isHittable() && FG[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),FG[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),FG[i]->getPosX(),FG[i]->getPosY(),4,0,0))
 	        { FG[i]->setHitted(true); SCORE+=FG[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    for(int i=0;i<N_CL;i++) // Clam
 	     {
 	     	if(CL[i]->isHittable() && CL[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),CL[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),CL[i]->getPosX(),CL[i]->getPosY(),4,0,0))
 	        { CL[i]->setHitted(true); SCORE+=CL[i]->getScore(); PL->getWeapon(j)->hitSoft(); return; }
 	     }
 	    // Weapon con magic box
 	    for(int i=0;i<=11;i++)
 	     {
 	     	if(MOBILE[i]->isHittable() && MOBILE[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),MOBILE[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),MOBILE[i]->getPosX(),MOBILE[i]->getPosY(),4,4,2))
 	        {
 	         PL->getWeapon(j)->hitSoft(); MOBILE[i]->setHitted(true);
 	         if(MOBILE[i]->getEnergy()==1) 
 	          { BONUSB[i]->setStartX(*MOBILE[i]->getPosXP()); BONUSB[i]->setStartY(*MOBILE[i]->getPosYP()-10); BONUSB[i]->resetObj(true,MOBILE[i]->getBonusSeq(PL->getDress(),PL->getShild(),PL->getPowerUp())); }
 	         return;
 	        }
 	     } 	    
 	    // Weapon con mobile and static platforms
 	    for(int i=12;i<N_PLAT;i++)
 	     {
 	     	if(MOBILE[i]->isHittable() && MOBILE[i]->isActive())
 	       if(hitTestFast8(PL->getWeapon(j)->getActFrameColP(),MOBILE[i]->getActFrameColP(),PL->getWeapon(j)->getX(),PL->getWeapon(j)->getY(),MOBILE[i]->getPosX(),MOBILE[i]->getPosY(),4,MOBILE[i]->getHHit(),MOBILE[i]->getVHit()))
 	        { PL->getWeapon(j)->hitHard(); return; }
 	     }
 	   }
 	 }
 }

void collisionPlayerBullets()
 {
 	// Player con bullets
 	if(PL->isHittable() && !PL->isGold())
 	 {
    for(int i=0;i<N_P2;i++) // Plant mk2 bullets
     {
   	  for(int j=0;j<P2[i]->getNBullet();j++)
   	   if(P2[i]->getBullet(j)->isFired() && P2[i]->getBullet(j)->canHit())
   	    if(hitTestFast8(P2[i]->getBullet(j)->getActFrameColP(),PL->getActFrameColP(),P2[i]->getBullet(j)->getX(),P2[i]->getBullet(j)->getY(),PL->getX(),PL->getY(),4,0,0))
         { PL->setHitted(true); P2[i]->getBullet(j)->hit(); return; }
     }
    for(int i=0;i<N_GI;i++) // Giant bullets
     {
   	  for(int j=0;j<GI[i]->getNBullet();j++)
   	   if(GI[i]->getBullet(j)->isFired() && GI[i]->getBullet(j)->canHit())
   	    if(hitTestFast8(GI[i]->getBullet(j)->getActFrameColP(),PL->getActFrameColP(),GI[i]->getBullet(j)->getX(),GI[i]->getBullet(j)->getY(),PL->getX(),PL->getY(),4,0,0))
         { PL->setHitted(true); GI[i]->getBullet(j)->hit(); return; }
     }
    for(int i=0;i<N_FG;i++) // Fire grizzly bullets
     {
   	  for(int j=0;j<FG[i]->getNBullet();j++)
   	   if(FG[i]->getBullet(j)->isFired() && FG[i]->getBullet(j)->canHit())
   	    if(hitTestFast8(FG[i]->getBullet(j)->getActFrameColP(),PL->getActFrameColP(),FG[i]->getBullet(j)->getX(),FG[i]->getBullet(j)->getY(),PL->getX(),PL->getY(),4,0,0))
         { PL->setHitted(true); FG[i]->getBullet(j)->hit(); return; }
     }
    for(int i=0;i<N_CL;i++) // Clam bullets
     {
   	  for(int j=0;j<CL[i]->getNBullet();j++)
   	   if(CL[i]->getBullet(j)->isFired() && CL[i]->getBullet(j)->canHit())
   	    if(hitTestFast8(CL[i]->getBullet(j)->getActFrameColP(),PL->getActFrameColP(),CL[i]->getBullet(j)->getX(),CL[i]->getBullet(j)->getY(),PL->getX(),PL->getY(),4,0,0))
         { PL->setHitted(true); CL[i]->getBullet(j)->hit(); return; }
     }
   }
 }

void rePaint(int max_fps)
 {
 	int diff;
 	if(STRETCH) stretch_blit(VSCR,screen,0,0,G_RESX,G_RESY,0,0,SCREENX,SCREENY);
 	else blit(VSCR,screen,0,0,(SCREENX-G_RESX)/2,(SCREENY-G_RESY)/2,SCREENX,SCREENY);
 	if(VSYNC) vsync();
 	if(AR_Clock()>=MS+MSEC_TO_TIMER(1)) { MS=AR_Clock(); fps=FPS; FPS=0; } FPS++;
 	diff=(MSEC_TO_TIMER(1)/max_fps)-(AR_Clock()-OMS); if(diff>0) wait(diff);
 	OMS=AR_Clock();
 }

void debug(BITMAP *bmp, int alpha)
 {
 	if(key[KEY_F1])   { L_0=!L_0;     key[KEY_F1]=0; }
 	if(key[KEY_F2])   { L_1=!L_1;     key[KEY_F2]=0; }
 	if(key[KEY_F3])   { L_S=!L_S;     key[KEY_F3]=0; }
 	if(key[KEY_F4])   { L_H=!L_H;     key[KEY_F4]=0; }
 	if(key[KEY_F5])   { L_OSD=!L_OSD; key[KEY_F5]=0; }
 	if(key[KEY_F6])   { L_B=!L_B;     key[KEY_F6]=0; }
 	if(key[KEY_F7])   { VSYNC=!VSYNC; key[KEY_F7]=0; }
 	if(key[KEY_F8])   { DBUG=!DBUG;   key[KEY_F8]=0; }
 	if(key[KEY_PGUP]) { MFPS++;       key[KEY_PGUP]=0; }
 	if(key[KEY_PGDN]) { MFPS--;       key[KEY_PGDN]=0; }
 	if(key[KEY_D]) PL->setDress(2);
 	if(DBUG)
 	 {
 	 	textprintf_ex(bmp,font,0,216,makecol32(255,0,0),-1,"V.%s",VER);
 	 	textprintf_ex(bmp,font,0,0, makecol32(255,0,0),-1,"          | FPS: %d | Bonus seq.: %d | P. Layer %d",fps,BONUS_SEQ,PL->getActPlatLayer());
 	 	textprintf_ex(bmp,font,0,12,makecol32(255,0,0),-1,"(Pl) PosX:%d PosY:%d GlobX:%d GlobY:%d",PL->getPosX(),PL->getPosY(),PL->getGlobX(),PL->getGlobY());
 	 	textprintf_ex(bmp,font,0,24,makecol32(255,0,0),-1,"(Pl) ActTileX:%d (OS:%d) ActTileY:%d (OS:%d)",PL->getGlobX()/MAP1[STAGE]->getTileW(),PL->getGlobX()%MAP1[STAGE]->getTileW(),PL->getGlobY()/MAP1[STAGE]->getTileH(),PL->getGlobY()%MAP1[STAGE]->getTileH());
 	 	textprintf_ex(bmp,font,0,36,makecol32(255,0,0),-1,"(M1) ActTileY:%d (Offset:%d)",MAP1[STAGE]->getActTileY(),MAP1[STAGE]->getTileOffsetY());
 	 	textprintf_ex(bmp,font,0,48,makecol32(255,0,0),-1,"(M1) ScrollX:%d  ScrollY:%d",MAP1[STAGE]->getScrollX(),MAP1[STAGE]->getScrollY());
 	 	PL->debug();
 	 	for(int i=0;i<N_PLAT;i++) MOBILE[i]->debug();
 	 	MAP1[STAGE]->debug();
 	 }
/* 	set_trans_blender(0,0,0,alpha);
 	//textprintf_ex(bmp,font,1,10,makecol32(255,0,0),-1,"Scroll: Scroll_Y:%d TPos_Y:%d MaxT_Y:%d",SY,TPY,MTY);
 	textprintf_ex(bmp,font,1,20,makecol32(255,0,0),-1,"Player: X:%d Y:%d En:%d Bomb State: %d",PL1->getX(),PL1->getY(),PL1->getEnergy(),PL1->getBoP()->getExP()->getState());
 	for(int i=0;i<N_VE;i++)textprintf_ex(bmp,font,1,30+i*10,makecol32(255,0,0),-1,"VE[%d]: X:%d Y:%d En:%d",i,VE[i]->getX(),VE[i]->getY(),VE[i]->getEnergy());
 	textprintf_ex(bmp,font,1,80,makecol32(255,0,0),-1,"X_MOUSE: %d",mouse_x);
 	set_trans_blender(0,0,0,255);*/
 }
